;; INFO LICENSE
;;    This file is part of SnakeBubble.
;;    Copyright (C) 2018-2019 David Ramon Sevilla / Jose Vicente Anton Coy	
;;    SnakeBubble is free software: you can redistribute it and/or modify
;;    it under the terms of the GNU General Public License as published by
;;    the Free Software Foundation, either version 3 of the License, or
;;    (at your option) any later version.
;;
;;    SnakeBubble is distributed in the hope that it will be useful,
;;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;    GNU General Public License for more details.
;;
;;    You should have received a copy of the GNU General Public License
;;    along with SnakeBubble.  If not, see <https://www.gnu.org/licenses/>.
;;---------------------------------Fin license info----------------------------------------

.area _DATA
.area _CODE

;INCLUIDOS
.include "entity.h.s"
.include "iaengine.h.s"
.include "plataform.h.s"
;DEPENDENCIAS

.globl cpct_drawSolidBox_asm
.globl cpct_getScreenPtr_asm
.globl _rana_sp_0
.globl _rana_sp_1
.globl _rana_sp_2
.globl _rana_sp_3
.globl _gallina_sp_0
.globl _gallina_sp_1
.globl _gallina_sp_2
.globl _gallina_sp_3
.globl _raton_sp_0
.globl _raton_sp_1
.globl _raton_sp_2
.globl _raton_sp_3

;DATOS PRIVADOS

;DATOS PUBLICOS
.macro defineEnemyEntity name, x, y, w, h, vx, vy, ec, sc, type, len, zon, rol, life
    name'_data:
        defineDrawEntity name'_dw, x, y, w, h  ;;Parte dibujable
        name'_vx:    .db vx                   ;;Vel x
        name'_vy:    .db vy                   ;;Vel y
        name'_jump:  .db #-1                   ;;Indice de la tabla (-1 inactivo, -2 bajando)
        name'_state: .db #0                    ;;Estado de animacion (0: suelo_izq, 1: salta_izq, 2: baja_izq, 3: mueve_izq
                                               ;;                     4: suelo_der, 5: salta_der, 6: baja_der, 7: mueve_der
                                               ;;                     8: disp_izq,  9: disp_der)
        name'_dire:  .db #0                    ;;Direccion que mira el heroe: (0:mira_derecha, 1:mira_izquierda)
        name'_grav:  .db #0                    ;;Gravedad (0:gravedad_active, 1:gravedad_inactive)
        name'_startColl:  .dw ec               ;; donde esta la funcion para que la llame coll
        name'_endColl:  .dw sc                 ;; donde esta la funcion para que la llame coll
        name'_len:  .db len                    ;;Lentitud aqui se le asigna mas o menos lentitud al enemigo, cuanto mas tenga mas
                                               ;;tardara en responder
        name'_type:  .db type                  ;;tipo de enemigo (0 = rata, 1 = gallina, 2 = rana)
        name'_blen:  .db #0
        name'_zone:  .db zon                  ;;anchura zona por la que se mueve
        name'_bzone: .db #0                  ;;zona de la anchura donde esta
        name'_rol: .db rol                     ;; 0 da vueltas por su zona hasta que ve al jugador luego lo persigue(vigilante)
                                               ;; 1 persigue al jugador desde el principio (cazador)
        name'_anit: .db #5
        name'_anteriorx: .db  x           ;; Guarda la x antigua
        name'_anteriory: .db  y           ;; Guarda la y antigua
        name'_life: .db life                 ;; Si esta activo(1) o no(0)
        name'_rolint: .db rol            ;; sirve para saber si el rol ha cambiado
.endm

defineEnemyEntity enemigo1 45 40 #0x08 #0x10 1 1 Enemy_startCollision Enemy_endCollision 0 3 15 0 0
defineEnemyEntity enemigo2 45 40 #0x08 #0x10 1 1 Enemy_startCollision Enemy_endCollision 0 3 15 0 0
defineEnemyEntity enemigo3 45 40 #0x08 #0x10 1 1 Enemy_startCollision Enemy_endCollision 0 3 15 0 0
defineEnemyEntity enemigo4 45 40 #0x08 #0x10 1 1 Enemy_startCollision Enemy_endCollision 0 3 15 0 0
defineEnemyEntity enemigo5 45 40 #0x08 #0x10 1 1 Enemy_startCollision Enemy_endCollision 0 3 15 0 0
defineEnemyEntity enemigo6 45 40 #0x08 #0x10 1 1 Enemy_startCollision Enemy_endCollision 0 3 15 0 0
defineEnemyEntity enemigo7 45 40 #0x08 #0x10 1 1 Enemy_startCollision Enemy_endCollision 0 3 15 0 0
defineEnemyEntity enemigo8 45 40 #0x08 #0x10 1 1 Enemy_startCollision Enemy_endCollision 0 3 15 0 0

;;Constantes de los datos de los enemigos
num_ene = 8                       ;; Numero de los enemigos
tam_ene == 25                      ;; Numero de datos de cada burbuja 23
enemy_actual:  .dw #enemigo1_data ;; Enemigo actual
contador_ene:  .db #num_ene       ;; contador de enemigos

;;Constantes de las estructuras de datos
.equ en_x, 0
.equ en_y, 1
.equ en_w, 2
.equ en_h, 3
.equ en_vx, 4
.equ en_vy, 5
.equ en_jmp, 6
.equ en_sta, 7
.equ en_dir, 8
.equ en_gra, 9
.equ en_sl, 10
.equ en_sh, 11
.equ en_el, 12
.equ en_eh, 13
.equ en_len, 14
.equ en_type, 15
.equ en_blen, 16
.equ en_zon, 17
.equ en_bzon, 18
.equ en_rol, 19
.equ en_ant, 20
.equ en_antx, 21
.equ en_anty, 22
.equ en_life, 23
.equ en_rolint, 24

;;Tabla de saltos
enemy_jumptable:
    .db  #-6, #-6, #-5, #-5
    .db  #-5, #-5, #-4, #-4
    .db  #-3, #-3, #-2, #-2
    .db  #-1, #-1, #00, #00
    .db  #0x80

;FUNCIONES PRIVADAS

;-----------------------------------------------------------------------------------------------------------
;se le llama cuando se quiere activar el salto, si esta activo no se activa y se termina la llamada
EnemyStartJump:
    ld  a, en_jmp(ix)   ;accedemos al enemigo que sea
    cp  #-1             ;esta activado ?
    jr nz,activar_salto  ;oye si retorna que esta activo se sale
        ld en_jmp(ix), #0;;lo ponemos a cero
    activar_salto:
ret

;-----------------------------------------------------------------------------------------------------------
;controla el salto del enemmigo
EnemyJumpControl:
    ld  a, en_jmp(ix)       ;; A = entity_jump estado(indice de la matriz)
    cp  #-1
    jr z, final_del_salto
    cp  #-2
    jr z, final_del_salto

    ;;Obtener el valor del salto
    ld   a, en_jmp(ix)
    ld  hl, #enemy_jumptable;; HL = primera direccion de la tabla de salto
    ld   c, a               ;; |
    ld   b, #0              ;; \ BC = A (offset)
    add hl, bc              ;; HL += BC

    ;;Chocar con el techo
    ld  a, en_y(ix)         ;; A = entity_y
    cp  #15                  ;; entity_y == 15?
    jr  z, activar_gravedad ;; If 15, acabar subida
    cp  #16                  ;; entity_y == 16?
    jr  z, activar_gravedad ;; If 16, acabar subida
    cp  #17                  ;; entity_y == 17?
    jr  z, activar_gravedad ;; If 17, acabar subida
    cp  #18                  ;; entity_y == 17?
    jr  z, activar_gravedad ;; If 17, acabar subida

    ;;Ceck el final del salto
    ld  a, (hl)             ;; A = Jump Movement
    cp  #0x80               ;; Jump vaoue == 0x80?
    jr  z, activar_gravedad ;; If 0x80, acabar subida

    ;;Mover la entidad
    ld  b, a                ;; B = Movimiento de Salto
    ld  a, en_y(ix)        ;; A = entity_y
    add b                   ;; A + B
    ld  en_y(ix), a         ;; Actualizar entity_y

    ;;Incrementar la entidad_jump (indice)
    inc en_jmp(ix)         ;; entity_jump++
    final_del_salto:
ret
;---------------------------------------------------------------------------------
    ;;Put -2 in el index mientras estas bajando -2
    activar_gravedad:
        ld en_gra(ix), #0
        ld en_jmp(ix), #-1
    ret
;-----------------------------------------------------------------------------------------------------------
    ;;Put -1 in el index del jump cuando este acabar
    Eend_of_jump:
        ld  en_jmp(ix), #-1      ;; entity_jump = -1
    ret
;-----------------------------------------------------------------------------------------------------------
;gestiona la gravedad del enemigo

EnemyGravity:

    ld  a, en_gra(ix)     ;;Gravedad
    cp  #1                 ;;A=1: Gravedad desactivada
    jr z,no_hay_gravedad         ;;Si A==1, not_gravity

        ld  a, en_y(ix)      ;; vamos a comprobar que la y esta en su limite
        cp  #176             ;;
        jr z,no_hay_gravedad                ;;si lo esta llama a anular la gravedad y a terminar el salto

            ;;Baja el enemigo
            ld   a, en_y(ix)       ;;|
            add  en_vy(ix)         ;;|
            ld   en_y(ix), a       ;;\ entity_x + entity_vx
            ;;si tenia rol 1 se pasa a rol 1
            ld a, en_rolint(ix)
            cp #1 ;; si es cazador
            ret nz
            ld en_rol(ix), #1 ;; lo pasamos al cazador si baja
        ret
        no_hay_gravedad:
ret

;-----------------------------------------------------------------------------------------------------------
;pinta el enemigo
enemy_draw:
    call EnemySelectSprite
    ld  a, #0               ;; si es 0 (dibujar en ix), si es 1 (dibujar en iy)
    call drawEntity
ret

;-----------------------------------------------------------------------------------------------------------
;borra el enemigo
enemy_erase:
    ld  a, #0              ;; si es 0 (borrar en ix), si es 1 (borrar en iy)
    ld  h, en_antx(ix)
    ld  l, en_anty(ix)
    call eraseEntity       ;; Borrar nuestro enemigo
ret

;-----------------------------------------------------------------------------------------------------------
;borra el enemigo en el front buffer
enemy_erase_front:
    ld  a, #3              ;; si es 0 (borrar en ix), si es 1 (borrar en iy), 3(borra en ix pero en front buffer)
    ld  h, en_antx(ix)
    ld  l, en_anty(ix)
    call eraseEntity       ;; Borrar nuestro enemigo
ret

;FUNCIONES PUBLICAS
;-----------------------------------------------------------------------------------------------------------
;-----------------------------------------------------------------------------------------------------------
;-----------------------------------------------------------------------------------------------------------


;-----------------------------------------------------------------------------------------------------------
;nos sirve para actualizar a donde ira el personaje llama a iaengine
enemy_update::

    ld   a, #num_ene
    ld  ix, #enemigo1_data
    call setPosicionEnemigos

    do3:
        push af;;guardamos af en el registro de reserva
        ld a, 23(ix);; para comprobar si se ejecutar o no
        cp #0
        jr z,aquiseguimos
        ;;parte codigo a buclear (nueva palabra :) )
            ld  a, en_x(ix)
            ld  en_antx(ix), a
            ld  a, en_y(ix)
            ld  en_anty(ix), a
            call setComprobando
            call plataform_update
            call EnemyJumpControl
            call EnemyGravity
            call setPosicionEnemigo

            ld a, en_blen(ix)
            cp #0 ;; en el momento que sea cero se ejecuta otra vez la ia, si no significa que no se ha movido
            jr z, sigue3
                dec a
                ld en_blen(ix),a
                jp aquiseguimos
            sigue3:
            ;;Guardar posicion del enemigo para borrado en buffer
            ld  a,en_len(ix)
            ld  en_blen(ix),a

            call calcular

        ;;fin de parte a buclear
        aquiseguimos:
        ld   bc, #tam_ene
        add  ix, bc
        pop  af
        dec  a
        jr  nz, do3
ret
;-----------------------------------------------------------------------------------------------------------
;devolvemos nuestro puntero en hl
enemy1_getPtrHL::
    ld   hl, #enemigo1_dw_x   ;;Puntero hero_x
ret

enemy2_getPtrHL::
    ld   hl, #enemigo2_dw_x    ;;Puntero hero_x
ret

;-----------------------------------------------------------------------------------------------------------
;estas funciones cambiar el eje x, debe estar su referencia puesta en ix
;modifica registro a y la variable del objeto que se le pase como referencia x
movermeDerecha::
    ld en_dir(ix),#0 ;cambiamos la direccion en la que mira
    ld a,0(ix)
    cp  #68;; Mirar si A == 0 , limite derecho
    jr z, noD
    add  4(ix)
    ld 0(ix),a
    ret
    noD:
    ;;si esta en limite se le pone para que vaya a la izquierda
    ld en_bzon(ix), #0
ret

;-----------------------------------------------------------------------------------------------------------
;estas funciones cambiar el eje x, debe estar su referencia puesta en ix
;modifica registro a y la variable del objeto que se le pase como referencia x
movermeIzquierda::
    ld en_dir(ix),#1
    ld a,0(ix)
    cp  #4 ;; Mirar si A == 0 , limite izquierdo
    jr z, noI
    ld a,0(ix)
    sub  4(ix)
    ld 0(ix),a
    ret
    noI:
    ;;si esta en limite se le pone para que vaya a la derecha
    ld en_bzon(ix), #0
ret

;-----------------------------------------------------------------------------------------------------------
;esta funcion llama a enemy draw para pintar cada entidad de enemigo que existe
enemy_drawGroup::
    ld   a, #num_ene
    ld  ix, #enemigo1_data

    do:
        push af

        ld a, 23(ix);; para comprobar si se debe pintar o no
        cp #0
        jr z,seguirPitando

        call enemy_draw

        seguirPitando:
        ld   bc, #tam_ene
        add  ix, bc
        pop  af
        dec  a
        jr  nz, do
ret

;-----------------------------------------------------------------------------------------------------------
;esta funcion borra los enemigos que hayan
enemy_eraseGroup::
    ld   a, #num_ene
    ld  ix, #enemigo1_data

    do2:
        push af

        ld a, 23(ix);; para comprobar si se debe borrar o no
        cp #0
        jr z,seguirBorrando

        call enemy_erase

        seguirBorrando:
        ld   bc, #tam_ene
        add  ix, bc
        pop  af
        dec  a
        jr  nz, do2
ret

;-----------------------------------------------------------------------------------------------------------
;esta funcion llama a enemyStartJump cuando salta el enemigo
enemy_saltar::
    call EnemyStartJump
ret

;-----------------------------------------------------------------------------------------------------------
;nos sirve para bajar de las plataformas cuando el jugador huya :( no tendra escapatoria
Enemy_bajar::
    ;ld  en_gra(ix), #0
    ;ld  en_jmp(ix), #-1
    ld en_rol(ix), #0
    ld en_rolint(ix), #1
    ld en_zon(ix), #40
ret
;-----------------------------------------------------------------------------------------------------------
;
Enemy_startCollision::
    ;;Si estas saltando no gravedad
    ld  a, en_jmp(ix)     ;; A = entity_jump
    cp  #-2               ;; A == -2? Is jump active?
    jr z, no_gravedad     ;; Jump active, no gravedad
    cp  #-1           ;; A == -2? Is jump active?
    jr z, no_gravedad     ;; Jump active, no gravedad
    ret
    no_gravedad:
        ld en_gra(ix), #1          ;; Desactivar gravedad
ret
;-----------------------------------------------------------------------------------------------------------
;
Enemy_endCollision::
    ld  a, en_gra(ix)            ;;|
    cp  #1                        ;;|
    jr  nz, no_tocar_gravedad   ;; Si la gravedad esta desactivada..
        ld en_gra(ix), #0        ;; Activar gravedad
        ld en_jmp(ix), #-1        ;; desactivamos salto
    no_tocar_gravedad:
ret
;-----------------------------------------------------------------------------------------------------------
;cambia la animacion y prepara la animacion para pintarla
EnemySelectSprite:

    ld a, en_ant(ix)
    cp #0
    jr z,llamarAnimacion
        dec a
        ld en_ant(ix),a
        jr seguirAnimacion
    llamarAnimacion:
        call animacion
    seguirAnimacion:

    ld  a,en_sta(ix)            ;; A = entity_state
    cp  #0                      ;; A == 0? (0 esta en animacion movimiento 1)
    jr  z,movimiento1
    cp  #1                      ;; A == 1? (1 esta en animacion movimiento 2)
    jr  z,movimiento2
    cp  #2                      ;; A == 2? (2 esta atacando a la izq)
    jr  z,movimientoIzq
    cp  #3                      ;; A == 3? (3 esta atacando a la der)
    jr  z,movimientoDer


    ;;Dibujar sprite dependiendo del tipo y del estado del enemigo
    movimiento1:
      ld a, en_type(ix)
      cp  #0                      ;;es una rata
      jr  z,tip1

      cp  #1                      ;;es una gallina
      jr  z,tip2

      cp  #2                      ;;es una rana
      jr  z,tip3

        tip1:
            ld  hl, #_raton_sp_0
        ret

        tip2:
            ld  hl, #_gallina_sp_0
        ret

        tip3:
            ld  hl, #_rana_sp_0
        ret
    ret

    movimiento2:
      ld  a,en_type(ix)

      cp  #0                      ;;es una rata
      jr  z,tip4

      cp  #1                      ;;es una gallina
      jr  z,tip5

      cp  #2                      ;;es una rana
      jr  z,tip6

        tip4:
            ld  hl, #_raton_sp_1
        ret

        tip5:
            ld  hl, #_gallina_sp_1
        ret

        tip6:
            ld  hl, #_rana_sp_1
        ret
   ret

    movimientoIzq:
      ld  a,en_type(ix)

      cp  #0                      ;;es una rata
      jr  z,tip7

      cp  #1                      ;;es una gallina
      jr  z,tip8

      cp  #2                      ;;es una rana
      jr  z,tip9

        tip7:
            ld  hl, #_raton_sp_2
        ret

        tip8:
            ld  hl, #_gallina_sp_2
        ret

        tip9:
            ld  hl, #_rana_sp_2
        ret

    ret
    movimientoDer:
      ld  a,en_type(ix)

      cp  #0                      ;;es una rata
      jr  z,tip10

      cp  #1                      ;;es una gallina
      jr  z,tip11

      cp  #2                      ;;es una rana
      jr  z,tip12

        tip10:
            ld  hl, #_raton_sp_3
        ret

        tip11:
            ld  hl, #_gallina_sp_3
        ret

        tip12:
            ld  hl, #_rana_sp_3
        ret
    ret
ret
;-----------------------------------------------------------------------------------------------------------
;recargamos el tiempo para que se vea la animacion
animacion:
    dec a
    ld en_ant(ix), a

    ld a, en_sta(ix)

    cp #0
    jr z, recarga
    cp #1
    jr z, recarga2
    cp #2
    jr z, recarga
    cp #3
    jr z, recarga
    ret

    recarga:
        ld a, #5
        ld en_ant(ix), a
        ld a, #1
        ld en_sta(ix),a
    ret
    recarga2:
        ld a, #5
        ld en_ant(ix), a
        ld a, #0
        ld en_sta(ix),a
    ret

    final_animacion:
ret
;-----------------------------------------------------------------------------------------------------------
;Esto es llamado por ia cuando el jugador esta cerca del enemigo,lo llama una vez en su tiempo de calculo(en_blen)
Enemy_ataca::

    ;recargamos animacion
    ld a, #5
    ld en_ant(ix), a
    ;fin de recarga

    ;primero cambiamos la animacion a ataque segun donde mire el enemigo si el enemigo no esta mirando no puede atacar
    ;(0:mira_derecha, 1:mira_izquierda)
    ld a, en_dir(ix)
    cp #0
    jr z, atacarDerecha
    cp #1
    jr z, atacarIzquierda

    atacarDerecha:
        ;cambiamos su estado a 3
        ld a, #3
        ld en_sta(ix),a
        ld en_blen(ix), #5
        ;;se le llamaria a la funcion de causar daño al jugador
    ret

    atacarIzquierda:
        ;cambiamos su estado a 2
        ld a, #2
        ld en_sta(ix),a
        ld  en_blen(ix),#5
        ;;se le llamaria a la funcion de quitar vida al jugador
    ret
ret
;-----------------------------------------------------------------------------------------------------------
;Esta funcion es llamada cuando una burbuja da al enemigo
Enemy_quitarVida::
    ;;muere el enemigo
    ld d, #1 ;; para indicarle que queremos borrar el front
    call enemy_erase_front
    ld en_life(ix), #0
ret
;-------------------------------------------------------------------------------------------------------------
;; desactiva todos los enemigos
Enemy_Desactivar_Todos::
    ld   a, #num_ene
    ld  ix, #enemigo1_data

    do6:
        push af

        ld a, 23(ix);; para comprobar si se debe borrar o no
        cp #0
        jr z,seguirDesactivando

        call Enemy_quitarVida

        seguirDesactivando:
        ld   bc, #tam_ene
        add  ix, bc
        pop  af
        dec  a
        jr  nz, do6
ret
;-------------------------------------------------------------------------------------------------------------------
;; comprueba si todos los enemigos estan muertos si lo estan devuelve en D == 1, si no devuelve D == 0
Estan_todos_death::
    ld   a, #num_ene
    ld  ix, #enemigo1_data
    do7:
        push af

        ld a, 23(ix);; para comprobar si se debe borrar o no
        cp #0
        jr z,seguirCompro

        jr hay_uno_vivo

        seguirCompro:
        ld   bc, #tam_ene
        add  ix, bc
        pop  af
        dec  a
        jr  nz, do7
        ld  d, #1 ;; estan todos muertos
    ret
    hay_uno_vivo: ;; hay vivos ..... Corre jugador o moriras
    pop  af ;; quitamos de la pila
    ld  d, #0 ;; hay vivos
ret
;---------------------------------------------------------------------------------------------------------------------
;; inicializa o resetea los enemigos del nivel que se le pase en A, si no reconoce el nivel desactiva todos los enemigos
initEnemigos::
    cp #0
    jp z, nivel0
    cp #1
    jp z, nivel1
    cp #2
    jp z, nivel2
    cp #3
    jp z, nivel3
    cp #4
    jp z, nivel4
    cp #5
    jp z, nivel5
    cp #6
    jp z, nivel6
    cp #7
    jp z, nivel7
    cp #8
    jp z, nivel8
    ret

    nivel0:
         call Enemy_Desactivar_Todos ;; primero desactivamos todos los enemigos

         ld  ix, #enemigo1_data
         ld  en_x(ix),#25 ;; posicion x
         ld  en_y(ix),#130 ;;posicion y
         ld  en_dir(ix),#0 ;; donde mira
         ld  en_len(ix), #1 ;;veces de ejecucion de la ia por cada del jugador (por defecto 3)
         ld  en_blen(ix), #0 ;;contador de la ejecucion(por defecto 0)
         ld  en_zon(ix), #20 ;;contador de zona (por defecto 5)
         ld  en_bzon(ix), #0 ;;contador de zona por la que estas(por defecto 0)
         ld  en_rol(ix), #0 ;;rol del enemigo 0 vigilante, 1 cazador
         ld  en_type(ix), #2 ;; 0 = rata, 1 = gallina, 2 = rana
         ld  en_rolint(ix), #0 ;; esto es para cuando se active modo cazador que vaya de un modo a otro
         ld  en_life(ix), #1 ;;activamos el enemigo (por defecto 1)

         ld  ix, #enemigo2_data
         ld  en_x(ix),#48 ;; posicion x
         ld  en_y(ix),#130 ;;posicion y
         ld  en_dir(ix),#1 ;; donde mira
         ld  en_len(ix), #1 ;;veces de ejecucion de la ia por cada del jugador (por defecto 3)
         ld  en_blen(ix), #0 ;;contador de la ejecucion(por defecto 0)
         ld  en_zon(ix), #20 ;;contador de zona (por defecto 5)
         ld  en_bzon(ix), #0 ;;contador de zona por la que estas(por defecto 0)
         ld  en_rol(ix), #0 ;;rol del enemigo 0 vigilante, 1 cazador
         ld  en_type(ix), #2 ;; 0 = rata, 1 = gallina, 2 = rana
         ld  en_rolint(ix), #0 ;; esto es para cuando se active modo cazador que vaya de un modo a otro
         ld  en_life(ix), #1 ;;activamos el enemigo (por defecto 1)

         ld  ix, #enemigo3_data
         ld  en_x(ix),#29 ;; posicion x
         ld  en_y(ix),#92 ;;posicion y
         ld  en_dir(ix),#1 ;; donde mira
         ld  en_len(ix), #1 ;;veces de ejecucion de la ia por cada del jugador (por defecto 3)
         ld  en_blen(ix), #0 ;;contador de la ejecucion(por defecto 0)
         ld  en_zon(ix), #15 ;;contador de zona (por defecto 5)
         ld  en_bzon(ix), #0 ;;contador de zona por la que estas(por defecto 0)
         ld  en_rol(ix), #0 ;;rol del enemigo 0 vigilante, 1 cazador
         ld  en_type(ix), #2 ;; 0 = rata, 1 = gallina, 2 = rana
         ld  en_rolint(ix), #0 ;; esto es para cuando se active modo cazador que vaya de un modo a otro
         ld  en_life(ix), #1 ;;activamos el enemigo (por defecto 1)

    ret
    nivel1:
         call Enemy_Desactivar_Todos ;; primero desactivamos todos los enemigos

         ld  ix, #enemigo1_data
         ld  en_x(ix),#20 ;; posicion x
         ld  en_y(ix),#130 ;;posicion y
         ld  en_dir(ix),#0 ;; donde mira
         ld  en_len(ix), #1 ;;veces de ejecucion de la ia por cada del jugador (por defecto 3)
         ld  en_blen(ix), #0 ;;contador de la ejecucion(por defecto 0)
         ld  en_zon(ix), #20 ;;contador de zona (por defecto 5)
         ld  en_bzon(ix), #0 ;;contador de zona por la que estas(por defecto 0)
         ld  en_rol(ix), #0 ;;rol del enemigo 0 vigilante, 1 cazador
         ld  en_type(ix), #2 ;; 0 = rata, 1 = gallina, 2 = rana
         ld  en_rolint(ix), #0 ;; esto es para cuando se active modo cazador que vaya de un modo a otro
         ld  en_life(ix), #1 ;;activamos el enemigo (por defecto 1)

         ld  ix, #enemigo2_data
         ld  en_x(ix),#53 ;; posicion x
         ld  en_y(ix),#92 ;;posicion y
         ld  en_dir(ix),#1 ;; donde mira
         ld  en_len(ix), #1 ;;veces de ejecucion de la ia por cada del jugador (por defecto 3)
         ld  en_blen(ix), #0 ;;contador de la ejecucion(por defecto 0)
         ld  en_zon(ix), #20 ;;contador de zona (por defecto 5)
         ld  en_bzon(ix), #0 ;;contador de zona por la que estas(por defecto 0)
         ld  en_rol(ix), #0 ;;rol del enemigo 0 vigilante, 1 cazador
         ld  en_type(ix), #2 ;; 0 = rata, 1 = gallina, 2 = rana
         ld  en_rolint(ix), #0 ;; esto es para cuando se active modo cazador que vaya de un modo a otro
         ld  en_life(ix), #1 ;;activamos el enemigo (por defecto 1)

         ld  ix, #enemigo3_data
         ld  en_x(ix),#5 ;; posicion x
         ld  en_y(ix),#52 ;;posicion y
         ld  en_dir(ix),#1 ;; donde mira
         ld  en_len(ix), #1 ;;veces de ejecucion de la ia por cada del jugador (por defecto 3)
         ld  en_blen(ix), #0 ;;contador de la ejecucion(por defecto 0)
         ld  en_zon(ix), #15 ;;contador de zona (por defecto 5)
         ld  en_bzon(ix), #0 ;;contador de zona por la que estas(por defecto 0)
         ld  en_rol(ix), #0 ;;rol del enemigo 0 vigilante, 1 cazador
         ld  en_type(ix), #2 ;; 0 = rata, 1 = gallina, 2 = rana
         ld  en_rolint(ix), #0 ;; esto es para cuando se active modo cazador que vaya de un modo a otro
         ld  en_life(ix), #1 ;;activamos el enemigo (por defecto 1)

    ret
    nivel2:
         call Enemy_Desactivar_Todos ;; primero desactivamos todos los enemigos

         ld  ix, #enemigo1_data
         ld  en_x(ix),#71 ;; posicion x
         ld  en_y(ix),#84 ;;posicion y
         ld  en_dir(ix),#0 ;; donde mira
         ld  en_len(ix), #1 ;;veces de ejecucion de la ia por cada del jugador (por defecto 3)
         ld  en_blen(ix), #0 ;;contador de la ejecucion(por defecto 0)
         ld  en_zon(ix), #20 ;;contador de zona (por defecto 5)
         ld  en_bzon(ix), #0 ;;contador de zona por la que estas(por defecto 0)
         ld  en_rol(ix), #1 ;;rol del enemigo 0 vigilante, 1 cazador
         ld  en_type(ix), #0 ;; 0 = rata, 1 = gallina, 2 = rana
         ld  en_rolint(ix), #1 ;; esto es para cuando se active modo cazador que vaya de un modo a otro
         ld  en_life(ix), #1 ;;activamos el enemigo (por defecto 1)

         ld  ix, #enemigo2_data
         ld  en_x(ix),#4 ;; posicion x
         ld  en_y(ix),#44 ;;posicion y
         ld  en_dir(ix),#0 ;; donde mira
         ld  en_len(ix), #1 ;;veces de ejecucion de la ia por cada del jugador (por defecto 3)
         ld  en_blen(ix), #0 ;;contador de la ejecucion(por defecto 0)
         ld  en_zon(ix), #70 ;;contador de zona (por defecto 5)
         ld  en_bzon(ix), #0 ;;contador de zona por la que estas(por defecto 0)
         ld  en_rol(ix), #0 ;;rol del enemigo 0 vigilante, 1 cazador
         ld  en_type(ix), #2 ;; 0 = rata, 1 = gallina, 2 = rana
         ld  en_rolint(ix), #0 ;; esto es para cuando se active modo cazador que vaya de un modo a otro
         ld  en_life(ix), #1 ;;activamos el enemigo (por defecto 1)

    ret
    nivel3:

         call Enemy_Desactivar_Todos ;; primero desactivamos todos los enemigos

         ld  ix, #enemigo1_data
         ld  en_x(ix),#45 ;; posicion x
         ld  en_y(ix),#36 ;;posicion y
         ld  en_dir(ix),#1 ;; donde mira
         ld  en_len(ix), #1 ;;veces de ejecucion de la ia por cada del jugador (por defecto 3)
         ld  en_blen(ix), #0 ;;contador de la ejecucion(por defecto 0)
         ld  en_zon(ix), #20 ;;contador de zona (por defecto 5)
         ld  en_bzon(ix), #0 ;;contador de zona por la que estas(por defecto 0)
         ld  en_rol(ix), #0 ;;rol del enemigo 0 vigilante, 1 cazador
         ld  en_type(ix), #0 ;; 0 = rata, 1 = gallina, 2 = rana
         ld  en_rolint(ix), #0 ;; esto es para cuando se active modo cazador que vaya de un modo a otro
         ld  en_life(ix), #1 ;;activamos el enemigo (por defecto 1)

         ld  ix, #enemigo2_data
         ld  en_x(ix),#4 ;; posicion x
         ld  en_y(ix),#84 ;;posicion y
         ld  en_dir(ix),#0 ;; donde mira
         ld  en_len(ix), #1 ;;veces de ejecucion de la ia por cada del jugador (por defecto 3)
         ld  en_blen(ix), #0 ;;contador de la ejecucion(por defecto 0)
         ld  en_zon(ix), #15 ;;contador de zona (por defecto 5)
         ld  en_bzon(ix), #0 ;;contador de zona por la que estas(por defecto 0)
         ld  en_rol(ix), #0 ;;rol del enemigo 0 vigilante, 1 cazador
         ld  en_type(ix), #0 ;; 0 = rata, 1 = gallina, 2 = rana
         ld  en_rolint(ix), #0 ;; esto es para cuando se active modo cazador que vaya de un modo a otro
         ld  en_life(ix), #1 ;;activamos el enemigo (por defecto 1)

         ld  ix, #enemigo3_data
         ld  en_x(ix),#4 ;; posicion x
         ld  en_y(ix),#44 ;;posicion y
         ld  en_dir(ix),#0 ;; donde mira
         ld  en_len(ix), #1 ;;veces de ejecucion de la ia por cada del jugador (por defecto 3)
         ld  en_blen(ix), #0 ;;contador de la ejecucion(por defecto 0)
         ld  en_zon(ix), #70 ;;contador de zona (por defecto 5)
         ld  en_bzon(ix), #0 ;;contador de zona por la que estas(por defecto 0)
         ld  en_rol(ix), #1 ;;rol del enemigo 0 vigilante, 1 cazador
         ld  en_type(ix), #2 ;; 0 = rata, 1 = gallina, 2 = rana
         ld  en_rolint(ix), #1 ;; esto es para cuando se active modo cazador que vaya de un modo a otro
         ld  en_life(ix), #1 ;;activamos el enemigo (por defecto 1)

    ret
    nivel4:

         call Enemy_Desactivar_Todos ;; primero desactivamos todos los enemigos


         ld  ix, #enemigo1_data
         ld  en_x(ix),#65 ;; posicion x
         ld  en_y(ix),#92 ;;posicion y
         ld  en_dir(ix),#1 ;; donde mira
         ld  en_len(ix), #1 ;;veces de ejecucion de la ia por cada del jugador (por defecto 3)
         ld  en_blen(ix), #0 ;;contador de la ejecucion(por defecto 0)
         ld  en_zon(ix), #10 ;;contador de zona (por defecto 5)
         ld  en_bzon(ix), #0 ;;contador de zona por la que estas(por defecto 0)
         ld  en_rol(ix), #0 ;;rol del enemigo 0 vigilante, 1 cazador
         ld  en_type(ix), #1 ;; 0 = rata, 1 = gallina, 2 = rana
         ld  en_rolint(ix), #0 ;; esto es para cuando se active modo cazador que vaya de un modo a otro
         ld  en_life(ix), #1 ;;activamos el enemigo (por defecto 1)

         ld  ix, #enemigo2_data
         ld  en_x(ix),#6 ;; posicion x
         ld  en_y(ix),#84 ;;posicion y
         ld  en_dir(ix),#0 ;; donde mira
         ld  en_len(ix), #1 ;;veces de ejecucion de la ia por cada del jugador (por defecto 3)
         ld  en_blen(ix), #0 ;;contador de la ejecucion(por defecto 0)
         ld  en_zon(ix), #10 ;;contador de zona (por defecto 5)
         ld  en_bzon(ix), #0 ;;contador de zona por la que estas(por defecto 0)
         ld  en_rol(ix), #0 ;;rol del enemigo 0 vigilante, 1 cazador
         ld  en_type(ix), #1 ;; 0 = rata, 1 = gallina, 2 = rana
         ld  en_rolint(ix), #0 ;; esto es para cuando se active modo cazador que vaya de un modo a otro
         ld  en_life(ix), #1 ;;activamos el enemigo (por defecto 1)

         ld  ix, #enemigo3_data
         ld  en_x(ix),#21 ;; posicion x
         ld  en_y(ix),#44 ;;posicion y
         ld  en_dir(ix),#1 ;; donde mira
         ld  en_len(ix), #1 ;;veces de ejecucion de la ia por cada del jugador (por defecto 3)
         ld  en_blen(ix), #0 ;;contador de la ejecucion(por defecto 0)
         ld  en_zon(ix), #30 ;;contador de zona (por defecto 5)
         ld  en_bzon(ix), #0 ;;contador de zona por la que estas(por defecto 0)
         ld  en_rol(ix), #0 ;;rol del enemigo 0 vigilante, 1 cazador
         ld  en_type(ix), #0 ;; 0 = rata, 1 = gallina, 2 = rana
         ld  en_rolint(ix), #0 ;; esto es para cuando se active modo cazador que vaya de un modo a otro
         ld  en_life(ix), #1 ;;activamos el enemigo (por defecto 1)

         ld  ix, #enemigo4_data
         ld  en_x(ix),#61 ;; posicion x
         ld  en_y(ix),#44 ;;posicion y
         ld  en_dir(ix),#0 ;; donde mira
         ld  en_len(ix), #1 ;;veces de ejecucion de la ia por cada del jugador (por defecto 3)
         ld  en_blen(ix), #0 ;;contador de la ejecucion(por defecto 0)
         ld  en_zon(ix), #70 ;;contador de zona (por defecto 5)
         ld  en_bzon(ix), #0 ;;contador de zona por la que estas(por defecto 0)
         ld  en_rol(ix), #1 ;;rol del enemigo 0 vigilante, 1 cazador
         ld  en_type(ix), #0 ;; 0 = rata, 1 = gallina, 2 = rana
         ld  en_rolint(ix), #1 ;; esto es para cuando se active modo cazador que vaya de un modo a otro
         ld  en_life(ix), #1 ;;activamos el enemigo (por defecto 1)

    ret
    nivel5:

        call Enemy_Desactivar_Todos ;; primero desactivamos todos los enemigos

         ld  ix, #enemigo1_data
         ld  en_x(ix),#16 ;; posicion x
         ld  en_y(ix),#132 ;;posicion y
         ld  en_dir(ix),#1 ;; donde mira
         ld  en_len(ix), #1 ;;veces de ejecucion de la ia por cada del jugador (por defecto 3)
         ld  en_blen(ix), #0 ;;contador de la ejecucion(por defecto 0)
         ld  en_zon(ix), #10 ;;contador de zona (por defecto 5)
         ld  en_bzon(ix), #0 ;;contador de zona por la que estas(por defecto 0)
         ld  en_rol(ix), #0 ;;rol del enemigo 0 vigilante, 1 cazador
         ld  en_type(ix), #1 ;; 0 = rata, 1 = gallina, 2 = rana
         ld  en_rolint(ix), #0 ;; esto es para cuando se active modo cazador que vaya de un modo a otro
         ld  en_life(ix), #1 ;;activamos el enemigo (por defecto 1)

         ld  ix, #enemigo2_data
         ld  en_x(ix),#58 ;; posicion x
         ld  en_y(ix),#92 ;;posicion y
         ld  en_dir(ix),#0 ;; donde mira
         ld  en_len(ix), #1 ;;veces de ejecucion de la ia por cada del jugador (por defecto 3)
         ld  en_blen(ix), #0 ;;contador de la ejecucion(por defecto 0)
         ld  en_zon(ix), #10 ;;contador de zona (por defecto 5)
         ld  en_bzon(ix), #0 ;;contador de zona por la que estas(por defecto 0)
         ld  en_rol(ix), #0 ;;rol del enemigo 0 vigilante, 1 cazador
         ld  en_type(ix), #0 ;; 0 = rata, 1 = gallina, 2 = rana
         ld  en_rolint(ix), #0 ;; esto es para cuando se active modo cazador que vaya de un modo a otro
         ld  en_life(ix), #1 ;;activamos el enemigo (por defecto 1)

         ld  ix, #enemigo3_data
         ld  en_x(ix),#16 ;; posicion x
         ld  en_y(ix),#52 ;;posicion y
         ld  en_dir(ix),#1 ;; donde mira
         ld  en_len(ix), #1 ;;veces de ejecucion de la ia por cada del jugador (por defecto 3)
         ld  en_blen(ix), #0 ;;contador de la ejecucion(por defecto 0)
         ld  en_zon(ix), #10 ;;contador de zona (por defecto 5)
         ld  en_bzon(ix), #0 ;;contador de zona por la que estas(por defecto 0)
         ld  en_rol(ix), #0 ;;rol del enemigo 0 vigilante, 1 cazador
         ld  en_type(ix), #1 ;; 0 = rata, 1 = gallina, 2 = rana
         ld  en_rolint(ix), #0 ;; esto es para cuando se active modo cazador que vaya de un modo a otro
         ld  en_life(ix), #1 ;;activamos el enemigo (por defecto 1)

    ret
    nivel6:

        call Enemy_Desactivar_Todos ;; primero desactivamos todos los enemigos

         ld  ix, #enemigo1_data
         ld  en_x(ix),#16 ;; posicion x
         ld  en_y(ix),#124 ;;posicion y
         ld  en_dir(ix),#1 ;; donde mira
         ld  en_len(ix), #1 ;;veces de ejecucion de la ia por cada del jugador (por defecto 3)
         ld  en_blen(ix), #0 ;;contador de la ejecucion(por defecto 0)
         ld  en_zon(ix), #10 ;;contador de zona (por defecto 5)
         ld  en_bzon(ix), #0 ;;contador de zona por la que estas(por defecto 0)
         ld  en_rol(ix), #0 ;;rol del enemigo 0 vigilante, 1 cazador
         ld  en_type(ix), #1 ;; 0 = rata, 1 = gallina, 2 = rana
         ld  en_rolint(ix), #0 ;; esto es para cuando se active modo cazador que vaya de un modo a otro
         ld  en_life(ix), #1 ;;activamos el enemigo (por defecto 1)

         ld  ix, #enemigo2_data
         ld  en_x(ix),#46 ;; posicion x
         ld  en_y(ix),#76 ;;posicion y
         ld  en_dir(ix),#1 ;; donde mira
         ld  en_len(ix), #1 ;;veces de ejecucion de la ia por cada del jugador (por defecto 3)
         ld  en_blen(ix), #0 ;;contador de la ejecucion(por defecto 0)
         ld  en_zon(ix), #20 ;;contador de zona (por defecto 5)
         ld  en_bzon(ix), #0 ;;contador de zona por la que estas(por defecto 0)
         ld  en_rol(ix), #0 ;;rol del enemigo 0 vigilante, 1 cazador
         ld  en_type(ix), #2 ;; 0 = rata, 1 = gallina, 2 = rana
         ld  en_rolint(ix), #0 ;; esto es para cuando se active modo cazador que vaya de un modo a otro
         ld  en_life(ix), #1 ;;activamos el enemigo (por defecto 1)

         ld  ix, #enemigo3_data
         ld  en_x(ix),#10 ;; posicion x
         ld  en_y(ix),#28 ;;posicion y
         ld  en_dir(ix),#0 ;; donde mira
         ld  en_len(ix), #1 ;;veces de ejecucion de la ia por cada del jugador (por defecto 3)
         ld  en_blen(ix), #0 ;;contador de la ejecucion(por defecto 0)
         ld  en_zon(ix), #20 ;;contador de zona (por defecto 5)
         ld  en_bzon(ix), #0 ;;contador de zona por la que estas(por defecto 0)
         ld  en_rol(ix), #0 ;;rol del enemigo 0 vigilante, 1 cazador
         ld  en_type(ix), #0 ;; 0 = rata, 1 = gallina, 2 = rana
         ld  en_rolint(ix), #0 ;; esto es para cuando se active modo cazador que vaya de un modo a otro
         ld  en_life(ix), #1 ;;activamos el enemigo (por defecto 1)

         ld  ix, #enemigo4_data
         ld  en_x(ix),#48 ;; posicion x
         ld  en_y(ix),#28 ;;posicion y
         ld  en_dir(ix),#0 ;; donde mira
         ld  en_len(ix), #1 ;;veces de ejecucion de la ia por cada del jugador (por defecto 3)
         ld  en_blen(ix), #0 ;;contador de la ejecucion(por defecto 0)
         ld  en_zon(ix), #20 ;;contador de zona (por defecto 5)
         ld  en_bzon(ix), #0 ;;contador de zona por la que estas(por defecto 0)
         ld  en_rol(ix), #0 ;;rol del enemigo 0 vigilante, 1 cazador
         ld  en_type(ix), #1 ;; 0 = rata, 1 = gallina, 2 = rana
         ld  en_rolint(ix), #0 ;; esto es para cuando se active modo cazador que vaya de un modo a otro
         ld  en_life(ix), #1 ;;activamos el enemigo (por defecto 1)

         ld  ix, #enemigo5_data
         ld  en_x(ix),#68 ;; posicion x
         ld  en_y(ix),#36 ;;posicion y
         ld  en_dir(ix),#1 ;; donde mira
         ld  en_len(ix), #1 ;;veces de ejecucion de la ia por cada del jugador (por defecto 3)
         ld  en_blen(ix), #0 ;;contador de la ejecucion(por defecto 0)
         ld  en_zon(ix), #10 ;;contador de zona (por defecto 5)
         ld  en_bzon(ix), #0 ;;contador de zona por la que estas(por defecto 0)
         ld  en_rol(ix), #0 ;;rol del enemigo 0 vigilante, 1 cazador
         ld  en_type(ix), #2 ;; 0 = rata, 1 = gallina, 2 = rana
         ld  en_rolint(ix), #1 ;; esto es para cuando se active modo cazador que vaya de un modo a otro
         ld  en_life(ix), #1 ;;activamos el enemigo (por defecto 1)

    ret
    nivel7:

         ld  ix, #enemigo1_data
         ld  en_x(ix),#57 ;; posicion x
         ld  en_y(ix),#108 ;;posicion y
         ld  en_dir(ix),#1 ;; donde mira
         ld  en_len(ix), #1 ;;veces de ejecucion de la ia por cada del jugador (por defecto 3)
         ld  en_blen(ix), #0 ;;contador de la ejecucion(por defecto 0)
         ld  en_zon(ix), #10 ;;contador de zona (por defecto 5)
         ld  en_bzon(ix), #0 ;;contador de zona por la que estas(por defecto 0)
         ld  en_rol(ix), #1 ;;rol del enemigo 0 vigilante, 1 cazador
         ld  en_type(ix), #1 ;; 0 = rata, 1 = gallina, 2 = rana
         ld  en_rolint(ix), #1 ;; esto es para cuando se active modo cazador que vaya de un modo a otro
         ld  en_life(ix), #1 ;;activamos el enemigo (por defecto 1)

         ld  ix, #enemigo2_data
         ld  en_x(ix),#15 ;; posicion x
         ld  en_y(ix),#108 ;;posicion y
         ld  en_dir(ix),#0 ;; donde mira
         ld  en_len(ix), #1 ;;veces de ejecucion de la ia por cada del jugador (por defecto 3)
         ld  en_blen(ix), #0 ;;contador de la ejecucion(por defecto 0)
         ld  en_zon(ix), #10 ;;contador de zona (por defecto 5)
         ld  en_bzon(ix), #0 ;;contador de zona por la que estas(por defecto 0)
         ld  en_rol(ix), #1 ;;rol del enemigo 0 vigilante, 1 cazador
         ld  en_type(ix), #1 ;; 0 = rata, 1 = gallina, 2 = rana
         ld  en_rolint(ix), #1 ;; esto es para cuando se active modo cazador que vaya de un modo a otro
         ld  en_life(ix), #1 ;;activamos el enemigo (por defecto 1)

         ld  ix, #enemigo3_data
         ld  en_x(ix),#35 ;; posicion x
         ld  en_y(ix),#76 ;;posicion y
         ld  en_dir(ix),#0 ;; donde mira
         ld  en_len(ix), #1 ;;veces de ejecucion de la ia por cada del jugador (por defecto 3)
         ld  en_blen(ix), #0 ;;contador de la ejecucion(por defecto 0)
         ld  en_zon(ix), #10 ;;contador de zona (por defecto 5)
         ld  en_bzon(ix), #0 ;;contador de zona por la que estas(por defecto 0)
         ld  en_rol(ix), #1 ;;rol del enemigo 0 vigilante, 1 cazador
         ld  en_type(ix), #1 ;; 0 = rata, 1 = gallina, 2 = rana
         ld  en_rolint(ix), #1 ;; esto es para cuando se active modo cazador que vaya de un modo a otro
         ld  en_life(ix), #1 ;;activamos el enemigo (por defecto 1)

         ld  ix, #enemigo4_data
         ld  en_x(ix),#5 ;; posicion x
         ld  en_y(ix),#44 ;;posicion y
         ld  en_dir(ix),#0 ;; donde mira
         ld  en_len(ix), #1 ;;veces de ejecucion de la ia por cada del jugador (por defecto 3)
         ld  en_blen(ix), #0 ;;contador de la ejecucion(por defecto 0)
         ld  en_zon(ix), #10 ;;contador de zona (por defecto 5)
         ld  en_bzon(ix), #0 ;;contador de zona por la que estas(por defecto 0)
         ld  en_rol(ix), #0 ;;rol del enemigo 0 vigilante, 1 cazador
         ld  en_type(ix), #0 ;; 0 = rata, 1 = gallina, 2 = rana
         ld  en_rolint(ix), #0 ;; esto es para cuando se active modo cazador que vaya de un modo a otro
         ld  en_life(ix), #1 ;;activamos el enemigo (por defecto 1)

         ld  ix, #enemigo5_data
         ld  en_x(ix),#65 ;; posicion x
         ld  en_y(ix),#44 ;;posicion y
         ld  en_dir(ix),#1 ;; donde mira
         ld  en_len(ix), #1 ;;veces de ejecucion de la ia por cada del jugador (por defecto 3)
         ld  en_blen(ix), #0 ;;contador de la ejecucion(por defecto 0)
         ld  en_zon(ix), #10 ;;contador de zona (por defecto 5)
         ld  en_bzon(ix), #0 ;;contador de zona por la que estas(por defecto 0)
         ld  en_rol(ix), #0 ;;rol del enemigo 0 vigilante, 1 cazador
         ld  en_type(ix), #0 ;; 0 = rata, 1 = gallina, 2 = rana
         ld  en_rolint(ix), #0 ;; esto es para cuando se active modo cazador que vaya de un modo a otro
         ld  en_life(ix), #1 ;;activamos el enemigo (por defecto 1)

    ret
    nivel8:

         ld  ix, #enemigo1_data
         ld  en_x(ix),#61 ;; posicion x
         ld  en_y(ix),#132 ;;posicion y
         ld  en_dir(ix),#1 ;; donde mira
         ld  en_len(ix), #1 ;;veces de ejecucion de la ia por cada del jugador (por defecto 3)
         ld  en_blen(ix), #0 ;;contador de la ejecucion(por defecto 0)
         ld  en_zon(ix), #10 ;;contador de zona (por defecto 5)
         ld  en_bzon(ix), #0 ;;contador de zona por la que estas(por defecto 0)
         ld  en_rol(ix), #1 ;;rol del enemigo 0 vigilante, 1 cazador
         ld  en_type(ix), #0 ;; 0 = rata, 1 = gallina, 2 = rana
         ld  en_rolint(ix), #1 ;; esto es para cuando se active modo cazador que vaya de un modo a otro
         ld  en_life(ix), #1 ;;activamos el enemigo (por defecto 1)

         ld  ix, #enemigo2_data
         ld  en_x(ix),#5 ;; posicion x
         ld  en_y(ix),#132 ;;posicion y
         ld  en_dir(ix),#1 ;; donde mira
         ld  en_len(ix), #1 ;;veces de ejecucion de la ia por cada del jugador (por defecto 3)
         ld  en_blen(ix), #0 ;;contador de la ejecucion(por defecto 0)
         ld  en_zon(ix), #10 ;;contador de zona (por defecto 5)
         ld  en_bzon(ix), #0 ;;contador de zona por la que estas(por defecto 0)
         ld  en_rol(ix), #1 ;;rol del enemigo 0 vigilante, 1 cazador
         ld  en_type(ix), #0 ;; 0 = rata, 1 = gallina, 2 = rana
         ld  en_rolint(ix), #1 ;; esto es para cuando se active modo cazador que vaya de un modo a otro
         ld  en_life(ix), #1 ;;activamos el enemigo (por defecto 1)

         ld  ix, #enemigo3_data
         ld  en_x(ix),#33 ;; posicion x
         ld  en_y(ix),#108 ;;posicion y
         ld  en_dir(ix),#0 ;; donde mira
         ld  en_len(ix), #1 ;;veces de ejecucion de la ia por cada del jugador (por defecto 3)
         ld  en_blen(ix), #0 ;;contador de la ejecucion(por defecto 0)
         ld  en_zon(ix), #10 ;;contador de zona (por defecto 5)
         ld  en_bzon(ix), #0 ;;contador de zona por la que estas(por defecto 0)
         ld  en_rol(ix), #1 ;;rol del enemigo 0 vigilante, 1 cazador
         ld  en_type(ix), #0 ;; 0 = rata, 1 = gallina, 2 = rana
         ld  en_rolint(ix), #1 ;; esto es para cuando se active modo cazador que vaya de un modo a otro
         ld  en_life(ix), #1 ;;activamos el enemigo (por defecto 1)

         ld  ix, #enemigo4_data
         ld  en_x(ix),#33 ;; posicion x
         ld  en_y(ix),#68 ;;posicion y
         ld  en_dir(ix),#1 ;; donde mira
         ld  en_len(ix), #1 ;;veces de ejecucion de la ia por cada del jugador (por defecto 3)
         ld  en_blen(ix), #0 ;;contador de la ejecucion(por defecto 0)
         ld  en_zon(ix), #6 ;;contador de zona (por defecto 5)
         ld  en_bzon(ix), #0 ;;contador de zona por la que estas(por defecto 0)
         ld  en_rol(ix), #0 ;;rol del enemigo 0 vigilante, 1 cazador
         ld  en_type(ix), #2 ;; 0 = rata, 1 = gallina, 2 = rana
         ld  en_rolint(ix), #0 ;; esto es para cuando se active modo cazador que vaya de un modo a otro
         ld  en_life(ix), #1 ;;activamos el enemigo (por defecto 1)

         ld  ix, #enemigo5_data
         ld  en_x(ix),#4 ;; posicion x
         ld  en_y(ix),#28 ;;posicion y
         ld  en_dir(ix),#0 ;; donde mira
         ld  en_len(ix), #1 ;;veces de ejecucion de la ia por cada del jugador (por defecto 3)
         ld  en_blen(ix), #0 ;;contador de la ejecucion(por defecto 0)
         ld  en_zon(ix), #10 ;;contador de zona (por defecto 5)
         ld  en_bzon(ix), #0 ;;contador de zona por la que estas(por defecto 0)
         ld  en_rol(ix), #0 ;;rol del enemigo 0 vigilante, 1 cazador
         ld  en_type(ix), #1 ;; 0 = rata, 1 = gallina, 2 = rana
         ld  en_rolint(ix), #0 ;; esto es para cuando se active modo cazador que vaya de un modo a otro
         ld  en_life(ix), #1 ;;activamos el enemigo (por defecto 1)

         ld  ix, #enemigo6_data
         ld  en_x(ix),#30 ;; posicion x
         ld  en_y(ix),#28 ;;posicion y
         ld  en_dir(ix),#1 ;; donde mira
         ld  en_len(ix), #1 ;;veces de ejecucion de la ia por cada del jugador (por defecto 3)
         ld  en_blen(ix), #0 ;;contador de la ejecucion(por defecto 0)
         ld  en_zon(ix), #10 ;;contador de zona (por defecto 5)
         ld  en_bzon(ix), #0 ;;contador de zona por la que estas(por defecto 0)
         ld  en_rol(ix), #0 ;;rol del enemigo 0 vigilante, 1 cazador
         ld  en_type(ix), #1 ;; 0 = rata, 1 = gallina, 2 = rana
         ld  en_rolint(ix), #0 ;; esto es para cuando se active modo cazador que vaya de un modo a otro
         ld  en_life(ix), #1 ;;activamos el enemigo (por defecto 1)

         ld  ix, #enemigo7_data
         ld  en_x(ix),#65 ;; posicion x
         ld  en_y(ix),#28 ;;posicion y
         ld  en_dir(ix),#1 ;; donde mira
         ld  en_len(ix), #1 ;;veces de ejecucion de la ia por cada del jugador (por defecto 3)
         ld  en_blen(ix), #0 ;;contador de la ejecucion(por defecto 0)
         ld  en_zon(ix), #10 ;;contador de zona (por defecto 5)
         ld  en_bzon(ix), #0 ;;contador de zona por la que estas(por defecto 0)
         ld  en_rol(ix), #0 ;;rol del enemigo 0 vigilante, 1 cazador
         ld  en_type(ix), #1 ;; 0 = rata, 1 = gallina, 2 = rana
         ld  en_rolint(ix), #0 ;; esto es para cuando se active modo cazador que vaya de un modo a otro
         ld  en_life(ix), #1 ;;activamos el enemigo (por defecto 1)
    ret
ret
