;; INFO LICENSE
;;    This file is part of SnakeBubble.
;;    Copyright (C) 2018-2019 David Ramon Sevilla / Jose Vicente Anton Coy	
;;    SnakeBubble is free software: you can redistribute it and/or modify
;;    it under the terms of the GNU General Public License as published by
;;    the Free Software Foundation, either version 3 of the License, or
;;    (at your option) any later version.
;;
;;    SnakeBubble is distributed in the hope that it will be useful,
;;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;    GNU General Public License for more details.
;;
;;    You should have received a copy of the GNU General Public License
;;    along with SnakeBubble.  If not, see <https://www.gnu.org/licenses/>.
;;---------------------------------Fin license info----------------------------------------

.area _DATA
.area _CODE
;EXPLICACION
;Esta clase sirve para que la ia le diga al enemigo que la haya llamado a donde tiene que ir,
;para esto antes debe el jugador enviar sus coordenadas, despues el enemigo que lo llame
;pasara sus coordenadas y llamara a calcular este le pondra a que funcion debe llamar
;INCLUIDOS
.include "enemy.h.s" ; para derecha, izquierda o salto
.include "collider.h.s" ; se utiliza para comprobar colisiones con la burbuja de cada enemigo que aun sigue vivo
.include "bubbles.h.s" ; se utiliza para comprobar colisiones con la burbuja de cada enemigo que aun sigue vivo
.include "hero.h.s" ; se utiliza para comprobar colisiones con la burbuja de cada enemigo que aun sigue vivo
;DEPENDENCIAS

;DATOS PRIVADOS
dJugador: .dw  #0x00,#0xC0  ;puntero a los datos del jugador
dEnemigo: .dw  #0x00,#0xC0  ;puntero a los datos del enemigo
dBurbuja: .dw  #0x00,#0xC0  ;puntero a los dados de la burbuja
dBurbujas: .dw  #0x00,#0xC0 ;puntero al array de las burbujas
dPTEnemigos: .dw  #0x00,#0xC0 ;puntero al array de los enemigos
;DATOS PUBLICOS

;FUNCIONES PRIVADAS
;;----------------------------------------------------------------------------------------------------------
;;comprueba si el jugador esta visible para el enemigo si el enemigo se mueve hacia el y esta en +5 lo ve
visible:
    ld ix,(dJugador)
    ld b, 1(ix) ;cargamos y del jugador
    ld ix,(dEnemigo)
    ld a, 1(ix) ;cargamos y del enemigo
    cp b
    jr nz, final_visible;;comprobamos primero que esten en la misma y si no lo estan no lo ve

        ld ix,(dJugador)
        ld b, 0(ix) ; cargamos x del jugador
        ld ix,(dEnemigo)
        ld a, 0(ix) ; cargamos x del enemigo
        ;;derecha 0, izquierda 1
        cp b
        jr c, esuno ; el enemigo esta a la izquierda
            jr z,esigual ;si es igual esta justo en el limite de la mira por lo que esta igualmente perdido el jugador
                ld a, 8(ix)
                cp #1
                jr nz,final_visible
                ld a, #1
                ld 19(ix), #1
            ret
            esigual: ;esto significa que es igual
                ld 19(ix), #1
                ld a, #1; esto significa que lo esta viendo
            ret
            esuno: ;esta a la derecha
            ;comprobamos para donde mira el enemigo
                ld a, 8(ix)
                cp #0
                jr nz,final_visible
                ld a, #1
                ld 19(ix), #1
            ret
    final_visible:
    ; esto significa que no esta viendo por lo que sigue su ruta
    ld a, #0
ret
;---------------------------------------------------------------------------------------------------------
;;en este rol el enemigo persigue al jugador este donde este
RolCazador:
    ;;llamamos a la funcion de moverse horizontalmente
    call calcular_cazador
    ;;llamamos a la funcion de moverse verticalmente
    call calcular_salto_cazador
ret
;---------------------------------------------------------------------------------------------------------
;;en este rol el vigilante se mueve de un lado para otro vigilando una zona hasta que ve al jugador y lo persegui(cambiaria al rol cazador)
RolVigilante:
    call visible;;comprobamos si vemos al jugador si es asi lo pasamos a modo 1
    cp #1
    jr z,RolCazador
    ;;hacemos que se mueve en una cantidad de pasos de vigilante
    ld ix,(dEnemigo)
    ld a, 18(ix)
    cp #0
    jr z, recarga_zona; si es cero recargamos y cambiamos la vista
    ; si no es cero dec y segun donde mire lo movemos aun lado o otro
    dec a
    ld 18(ix), a
    ld a,8(ix)
    cp #0
    jr z, mov_der
    cp #1
    jr z, mov_izq
    ret
    mov_der:
        call movermeDerecha
    ret
    mov_izq:
        call movermeIzquierda
    ret
    recarga_zona:
    ld a, 17(ix)
    ld 18(ix), a
    ld a, 8(ix)
    cp #0
    jr z, mir_der
    cp #1
    jr z, mir_izq
    ret
    mir_der:
        ld 8(ix), #1
    ret
    mir_izq:
        ld 8(ix), #0
    ret
ret
;----------------------------------------------------------------------------------------------------------------
;;le indica al enemigo si debe ir hacia la derecha o la izquierda
calcular_cazador:
    ld ix,(dJugador)
    ld b, 0(ix)
    ld ix,(dEnemigo)
    ;comprobamos a que lado mira
    ld a, 8(ix)
    cp #1
    jr c,es_mayor
        ld a, 0(ix) ; cargamos x del enemigo
        sub #6
        jr pasar
        ;si mira a la izquierdaa(1) se le suman
    es_mayor:
    ;si mira a la derecha(0) se le restan
    ld a, 0(ix) ; cargamos x del enemigo
    add #6
    pasar:
    cp b
    jr c, es_uno ; el enemigo esta a la izquierda
        jr z,atacar ;porque es igual
            call movermeIzquierda
            jr fin
        atacar:
                ld ix,(dJugador);comprobamos y
                ld b, 1(ix)
                ld ix,(dEnemigo) 
                ld a, 1(ix)
                cp b
                jr z, atacar2
            ret
            atacar2:
                call Enemy_ataca ;;hacemos que el enemigo pase a modo ataque
                call Quitar_Vida ;;quitamos vida al 
            ret
    es_uno: ; el enemigo esta a la derecha
        call movermeDerecha
    fin:
ret
;--------------------------------------------------------------------------
;le indica al enemigo si debe saltar o no
calcular_salto_cazador:
    ld ix,(dJugador)
    ld b, 1(ix)
    ld ix,(dEnemigo)
    ld a, 1(ix) ; cargamos x del enemigo
    cp b
    jr c, fin2 ; el enemigo esta a la izquierda
        jr z,fin3
            call enemy_saltar;que este mas arriba
            ret
        fin2:
            call Enemy_bajar
        ret
    fin3:
ret

;FUNCIONES PUBLICAS
;--------------------------------------------------------------------------
;;define los datos de x e y para el jugador
setPosicionJugador::
    ld (dJugador),ix
ret
;--------------------------------------------------------------------------
;;define los datos del enemigo
setPosicionEnemigo::
    ld (dEnemigo),ix
ret
;--------------------------------------------------------------------------
;;define los datos de las burbujas
setPosicionBurbujas::
    ld (dBurbujas),iy
ret
;--------------------------------------------------------------------------
;;define los datos del puntero donde esta el array de enemigos
setPosicionEnemigos::
    ld (dPTEnemigos),ix
ret
;--------------------------------------------------------------------------
;;se encarga de enviarlo al rol que pertenece
calcular::
    ld ix,(dEnemigo)
    ld a, 19(ix)
    cp #1
    jr z,Rol1
        call RolVigilante
    ret
    Rol1:
        call RolCazador
    final_deCalcular:
ret
;--------------------------------------------------------------------------
;; nos servira para saber si hay colision con alguna burbuja si la hay se llama a quitarVida del enemigo.
HayColision::
    ld   a, #8
    ld  ix, (dPTEnemigos)
    Inicio:
        push af

        ld a, 23(ix);; para comprobar si se debe de calcular la colision
        cp #0   ;;para compro
        jr z,final_interno

        ld (dEnemigo), ix          ;; Cargamos la posicion de ix en el enemigo para comprobarlo con ese enemigo
        ld   a, #5                ;; Numero de burbujas a dibujar
        ld  iy, (dBurbujas)       ;; IX Puntero a los datos de la primera burbuja

        do5:
            push af              ;; Guardar el contador A

            ld (dBurbuja), iy

            ld  a, 6(iy)      ;; If(ent_act(ix) == 0 desactivada)
            cp  #0
            jr  z, no_esta_activa

            ld  hl, (dBurbuja)
            ld  d, h
            ld  e, l
            ld  hl, (dEnemigo)

            ;;Solo llamar a colision si NO ha colisionado
            ld  a, 13(iy)           ;;ent_col
            cp  #1
            jr  z, no_hacer_colision
                ;;Solo llamar a colision si la burbuja se mueve en X
                ld  a, 8(iy)           ;;ent_dir
                cp  #1
                jr  z, no_hacer_colision

                    call checkCollision
                    ;; si esto devuelve a == 1 hay colision, si devuelve a == 0 no hay colision
                    cp #1
                    jr z,HayColisionTag
            no_hacer_colision:

            no_esta_activa:
            ld   bc, #15        ;; tam_bub
            add  iy, bc         ;; bub_data + tam_bub = siguiente burbuja
            pop  af             ;; Cargar el contador en A
            dec  a
            jr  nz, do5  ;; Borra tantas burbujas como num_bub
            ld a, #0
        jr final_interno

        HayColisionTag:
            pop  af
            ld ix, (dEnemigo)
            call Enemy_quitarVida
            ld a, 15(ix)    ;;en_type
            ld b,  0(ix)    ;;en_x
            call BurbujaEnemigo

    final_interno:
    ld   bc, #25
    add  ix, bc
    pop  af
    dec  a
    jr  nz, Inicio   
ret

;;Funcion que desactiva todos los enemigos
desactivar_enemigos::
    call Enemy_Desactivar_Todos
    ;;puedes hacer aqui la llamada
ret