;; INFO LICENSE
;;    This file is part of SnakeBubble.
;;    Copyright (C) 2018-2019 David Ramon Sevilla / Jose Vicente Anton Coy	
;;    SnakeBubble is free software: you can redistribute it and/or modify
;;    it under the terms of the GNU General Public License as published by
;;    the Free Software Foundation, either version 3 of the License, or
;;    (at your option) any later version.
;;
;;    SnakeBubble is distributed in the hope that it will be useful,
;;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;    GNU General Public License for more details.
;;
;;    You should have received a copy of the GNU General Public License
;;    along with SnakeBubble.  If not, see <https://www.gnu.org/licenses/>.
;;---------------------------------Fin license info----------------------------------------


.area _DATA
.area _CODE

.include "cpctelera.h.s"    ;;CPCtelera simbolos
.include "entity.h.s"
.include "hero.h.s"
.include "collider.h.s"
.include "level.h.s"

.globl _obstac_sp_0
.globl _obstac_sp_1
.globl _obstac_sp_2
.globl _obstac_sp_3
.globl _chicago_sp

.macro defineobstacleEntity name, x, y, w, h
    name'_data:
        defineDrawEntity name'_dw, x, y, w, h   ;; Parte dibujable
        name'_tiempo: .db  #10                  ;; Tiempo de danyo
        name'_tiempoanim: .db #20               ;; tiempo de animacion
        name'_anteriorx: .db  x                 ;; Guarda la x antigua
        name'_anteriory: .db  y                 ;; Guarda la y antigua
        name'_accion: .db #0                    ;; 0: no realiza ninguna accion
        name'_initx:  .db  x                    ;; x inicial
        name'_inity:  .db  y                    ;; y inicial
        name'_initim: .db #0                    ;; tiempo inincial animacion
        name'_initm: .db #0                     ;; tiempo inicial
.endm

.equ ent_tmp, 4
.equ ent_tmpa, 5
.equ ent_antx, 6
.equ ent_anty, 7
.equ ent_ac, 8
.equ ent_inx, 9
.equ ent_iny, 10
.equ ent_intim, 11
.equ ent_initm, 12

defineobstacleEntity pincho1 4 184 #0x50 #0x08
defineobstacleEntity pincho2 4 184 #0x50 #0x08
defineobstacleEntity pincho3 4 184 #0x50 #0x08
defineobstacleEntity pincho4 4 184 #0x50 #0x08
defineobstacleEntity pincho5 4 184 #0x50 #0x08
defineobstacleEntity carambano1 4 16 #0x04 #0x08
defineobstacleEntity carambano2 4 35 #0x04 #0x08
defineobstacleEntity carambano3 4 45 #0x04 #0x08
defineobstacleEntity cactus1 4 20 #0x04 #0x08
defineobstacleEntity cactus2 4 20 #0x04 #0x08
defineobstacleEntity cactus3 4 20 #0x04 #0x08
defineobstacleEntity flecha1 4 20 #0x04 #0x08
defineobstacleEntity flecha2 4 20 #0x04 #0x08
defineobstacleEntity flecha3 4 20 #0x04 #0x08
defineobstacleEntity chicago 4 20 #0x08 #0x10


;;===============================================================
;;===============================================================
;; PUBLIC FUNCTION
;;===============================================================
;;===============================================================

;;===============================================================
;; Inicialize Obstacles
;; DESTROY: A,IX
;; RETURNS: -
;;===============================================================
obstacle_init::
    ld  a, (nivel_actual)  ;;comprueba los niveles donde hay diferentes obstaculos
    cp  #1
    jr  nz, no_level1_init

        ld ix, #pincho1_data      ;; IX Puntero a los datos
        ld ent_x(ix), #4
        ld ent_y(ix), #184
        ld ent_w(ix), #0x50
        ld ent_h(ix), #0x08
        ld ent_tmp(ix), #10
        ld ent_initm(ix), #10

    no_level1_init:
    cp  #2
    jr  nz, no_level2_init

        ld ix, #carambano1_data      ;; IX Puntero a los datos
        ld ent_tmpa(ix), #35
        ld ent_x(ix), #24
        ld ent_y(ix), #16
        ld ent_w(ix), #0x04
        ld ent_h(ix), #0x08
        ;;guardar los iniciales para luego
        ld  a, ent_tmpa(ix)
        ld ent_intim(ix), a
        ld  a, ent_x(ix)
        ld  ent_inx(ix), a
        ld  a, ent_y(ix)
        ld  ent_iny(ix), a
        ld ent_tmp(ix), #2
        ld ent_initm(ix), #2

        ld ix, #carambano2_data      ;; IX Puntero a los datos
        ld ent_tmpa(ix), #60
        ld ent_x(ix), #53
        ld ent_y(ix), #16
        ld ent_w(ix), #0x04
        ld ent_h(ix), #0x08
        ;;guardar los iniciales para luego
        ld  a, ent_tmpa(ix)
        ld ent_intim(ix), a
        ld  a, ent_x(ix)
        ld  ent_inx(ix), a
        ld  a, ent_y(ix)
        ld  ent_iny(ix), a
        ld ent_tmp(ix), #2
        ld ent_initm(ix), #2

    no_level2_init:
    cp  #3
    jr  nz, no_level3_init

        ld ix, #cactus1_data      ;; IX Puntero a los datos
        ld ent_x(ix), #38
        ld ent_y(ix), #186
        ld ent_tmp(ix), #5
        ld ent_initm(ix), #5

        ld ix, #cactus2_data      ;; IX Puntero a los datos
        ld ent_x(ix), #24
        ld ent_y(ix), #98
        ld ent_tmp(ix), #5
        ld ent_initm(ix), #5

        ld ix, #cactus3_data      ;; IX Puntero a los datos
        ld ent_x(ix), #50
        ld ent_y(ix), #50
        ld ent_tmp(ix), #5
        ld ent_initm(ix), #5

        ld ix, #chicago_data      ;; IX Puntero a los datos
        ld ent_x(ix), #35
        ld ent_y(ix), #0

    no_level3_init:
    cp  #4
    jr  nz, no_level4_init

        ld ix, #pincho1_data      ;; IX Puntero a los datos
        ld ent_x(ix), #24
        ld ent_y(ix), #136
        ld ent_w(ix), #0x10
        ld ent_h(ix), #0x08
        ld ent_tmp(ix), #10
        ld ent_initm(ix), #10

        ld ix, #pincho2_data      ;; IX Puntero a los datos
        ld ent_x(ix), #48
        ld ent_y(ix), #136
        ld ent_w(ix), #0x10
        ld ent_h(ix), #0x08
        ld ent_tmp(ix), #10
        ld ent_initm(ix), #10

    no_level4_init:
    cp  #5
    jp  nz, no_level5_init

        ld ix, #flecha1_data      ;; IX Puntero a los datos
        ld ent_tmpa(ix), #10
        ld ent_x(ix), #4
        ld ent_y(ix), #96
        ld ent_w(ix), #0x04
        ld ent_h(ix), #0x08
        ;;guardar los iniciales para luego
        ld  a, ent_tmpa(ix)
        ld ent_intim(ix), a
        ld  a, ent_x(ix)
        ld  ent_inx(ix), a
        ld  a, ent_y(ix)
        ld  ent_iny(ix), a
        ld ent_tmp(ix), #2
        ld ent_initm(ix), #2

        ld ix, #flecha2_data      ;; IX Puntero a los datos
        ld ent_tmpa(ix), #10
        ld ent_x(ix), #72
        ld ent_y(ix), #137
        ld ent_w(ix), #0x04
        ld ent_h(ix), #0x08
        ;;guardar los iniciales para luego
        ld  a, ent_tmpa(ix)
        ld ent_intim(ix), a
        ld  a, ent_x(ix)
        ld  ent_inx(ix), a
        ld  a, ent_y(ix)
        ld  ent_iny(ix), a
        ld ent_tmp(ix), #2
        ld ent_initm(ix), #2

        ld ix, #flecha3_data      ;; IX Puntero a los datos
        ld ent_tmpa(ix), #10
        ld ent_x(ix), #72
        ld ent_y(ix), #57
        ld ent_w(ix), #0x04
        ld ent_h(ix), #0x08
        ;;guardar los iniciales para luego
        ld  a, ent_tmpa(ix)
        ld ent_intim(ix), a
        ld  a, ent_x(ix)
        ld  ent_inx(ix), a
        ld  a, ent_y(ix)
        ld  ent_iny(ix), a
        ld ent_tmp(ix), #2
        ld ent_initm(ix), #2

    no_level5_init:
    cp  #6
    jp  nz, no_level6_init

        ld ix, #cactus1_data      ;; IX Puntero a los datos
        ld ent_x(ix), #45
        ld ent_y(ix), #90
        ld ent_tmp(ix), #5
        ld ent_initm(ix), #5

        ld ix, #cactus2_data      ;; IX Puntero a los datos
        ld ent_x(ix), #30
        ld ent_y(ix), #42
        ld ent_tmp(ix), #5
        ld ent_initm(ix), #5

        ld ix, #pincho1_data      ;; IX Puntero a los datos
        ld ent_x(ix), #4
        ld ent_y(ix), #184
        ld ent_w(ix), #0x50
        ld ent_h(ix), #0x08
        ld ent_tmp(ix), #10
        ld ent_initm(ix), #10

        ld ix, #flecha1_data      ;; IX Puntero a los datos
        ld ent_tmpa(ix), #10
        ld ent_x(ix), #4
        ld ent_y(ix), #128
        ld ent_w(ix), #0x04
        ld ent_h(ix), #0x08
        ;;guardar los iniciales para luego
        ld  a, ent_tmpa(ix)
        ld ent_intim(ix), a
        ld  a, ent_x(ix)
        ld  ent_inx(ix), a
        ld  a, ent_y(ix)
        ld  ent_iny(ix), a
        ld ent_tmp(ix), #2
        ld ent_initm(ix), #2

        ld ix, #flecha2_data      ;; IX Puntero a los datos
        ld ent_tmpa(ix), #30
        ld ent_x(ix), #72
        ld ent_y(ix), #80
        ld ent_w(ix), #0x04
        ld ent_h(ix), #0x08
        ;;guardar los iniciales para luego
        ld  a, ent_tmpa(ix)
        ld ent_intim(ix), a
        ld  a, ent_x(ix)
        ld  ent_inx(ix), a
        ld  a, ent_y(ix)
        ld  ent_iny(ix), a
        ld ent_tmp(ix), #2
        ld ent_initm(ix), #2

    no_level6_init:
    cp  #7
    jp  nz, no_level7_init

        ld ix, #pincho1_data      ;; IX Puntero a los datos
        ld ent_x(ix), #4
        ld ent_y(ix), #184
        ld ent_w(ix), #0x50
        ld ent_h(ix), #0x08
        ld ent_tmp(ix), #10
        ld ent_initm(ix), #10

        ld ix, #carambano1_data      ;; IX Puntero a los datos
        ld ent_tmpa(ix), #15
        ld ent_x(ix), #18
        ld ent_y(ix), #16
        ld ent_w(ix), #0x04
        ld ent_h(ix), #0x08
        ;;guardar los iniciales para luego
        ld  a, ent_tmpa(ix)
        ld ent_intim(ix), a
        ld  a, ent_x(ix)
        ld  ent_inx(ix), a
        ld  a, ent_y(ix)
        ld  ent_iny(ix), a
        ld ent_tmp(ix), #2
        ld ent_initm(ix), #2

        ld ix, #carambano2_data      ;; IX Puntero a los datos
        ld ent_tmpa(ix), #25
        ld ent_x(ix), #38
        ld ent_y(ix), #16
        ld ent_w(ix), #0x04
        ld ent_h(ix), #0x08
        ;;guardar los iniciales para luego
        ld  a, ent_tmpa(ix)
        ld ent_intim(ix), a
        ld  a, ent_x(ix)
        ld  ent_inx(ix), a
        ld  a, ent_y(ix)
        ld  ent_iny(ix), a
        ld ent_tmp(ix), #2
        ld ent_initm(ix), #2

        ld ix, #carambano3_data      ;; IX Puntero a los datos
        ld ent_tmpa(ix), #17
        ld ent_x(ix), #58
        ld ent_y(ix), #16
        ld ent_w(ix), #0x04
        ld ent_h(ix), #0x08
        ;;guardar los iniciales para luego
        ld  a, ent_tmpa(ix)
        ld ent_intim(ix), a
        ld  a, ent_x(ix)
        ld  ent_inx(ix), a
        ld  a, ent_y(ix)
        ld  ent_iny(ix), a
        ld ent_tmp(ix), #2
        ld ent_initm(ix), #2

        ld ix, #flecha1_data      ;; IX Puntero a los datos
        ld ent_tmpa(ix), #10
        ld ent_x(ix), #4
        ld ent_y(ix), #113
        ld ent_w(ix), #0x04
        ld ent_h(ix), #0x08
        ;;guardar los iniciales para luego
        ld  a, ent_tmpa(ix)
        ld ent_intim(ix), a
        ld  a, ent_x(ix)
        ld  ent_inx(ix), a
        ld  a, ent_y(ix)
        ld  ent_iny(ix), a
        ld ent_tmp(ix), #2
        ld ent_initm(ix), #2

        ld ix, #flecha2_data      ;; IX Puntero a los datos
        ld ent_tmpa(ix), #10
        ld ent_x(ix), #72
        ld ent_y(ix), #49
        ld ent_w(ix), #0x04
        ld ent_h(ix), #0x08
        ;;guardar los iniciales para luego
        ld  a, ent_tmpa(ix)
        ld ent_intim(ix), a
        ld  a, ent_x(ix)
        ld  ent_inx(ix), a
        ld  a, ent_y(ix)
        ld  ent_iny(ix), a
        ld ent_tmp(ix), #2
        ld ent_initm(ix), #2

    no_level7_init:
    cp  #8
    jp  nz, no_level8_init

        ld ix, #pincho1_data      ;; IX Puntero a los datos
        ld ent_x(ix), #4
        ld ent_y(ix), #184
        ld ent_w(ix), #0x50
        ld ent_h(ix), #0x08
        ld ent_tmp(ix), #10
        ld ent_initm(ix), #10

        ld ix, #pincho2_data      ;; IX Puntero a los datos
        ld ent_x(ix), #4
        ld ent_y(ix), #144
        ld ent_w(ix), #0x0C
        ld ent_h(ix), #0x08
        ld ent_tmp(ix), #10
        ld ent_initm(ix), #10

        ld ix, #pincho3_data      ;; IX Puntero a los datos
        ld ent_x(ix), #64
        ld ent_y(ix), #144
        ld ent_w(ix), #0x0C
        ld ent_h(ix), #0x08
        ld ent_tmp(ix), #10
        ld ent_initm(ix), #10

        ld ix, #pincho4_data      ;; IX Puntero a los datos
        ld ent_x(ix), #36
        ld ent_y(ix), #120
        ld ent_w(ix), #0x08
        ld ent_h(ix), #0x08
        ld ent_tmp(ix), #10
        ld ent_initm(ix), #10

        ld ix, #pincho5_data      ;; IX Puntero a los datos
        ld ent_x(ix), #36
        ld ent_y(ix), #80
        ld ent_w(ix), #0x08
        ld ent_h(ix), #0x08
        ld ent_tmp(ix), #10
        ld ent_initm(ix), #10

        ld ix, #flecha1_data      ;; IX Puntero a los datos
        ld ent_tmpa(ix), #10
        ld ent_x(ix), #4
        ld ent_y(ix), #112
        ld ent_w(ix), #0x04
        ld ent_h(ix), #0x08
        ;;guardar los iniciales para luego
        ld  a, ent_tmpa(ix)
        ld ent_intim(ix), a
        ld  a, ent_x(ix)
        ld  ent_inx(ix), a
        ld  a, ent_y(ix)
        ld  ent_iny(ix), a
        ld ent_tmp(ix), #2
        ld ent_initm(ix), #2

        ld ix, #flecha2_data      ;; IX Puntero a los datos
        ld ent_tmpa(ix), #15
        ld ent_x(ix), #72
        ld ent_y(ix), #137
        ld ent_w(ix), #0x04
        ld ent_h(ix), #0x08
        ;;guardar los iniciales para luego
        ld  a, ent_tmpa(ix)
        ld ent_intim(ix), a
        ld  a, ent_x(ix)
        ld  ent_inx(ix), a
        ld  a, ent_y(ix)
        ld  ent_iny(ix), a
        ld ent_tmp(ix), #2
        ld ent_initm(ix), #2

        ld ix, #flecha3_data      ;; IX Puntero a los datos
        ld ent_tmpa(ix), #10
        ld ent_x(ix), #72
        ld ent_y(ix), #33
        ld ent_w(ix), #0x04
        ld ent_h(ix), #0x08
        ;;guardar los iniciales para luego
        ld  a, ent_tmpa(ix)
        ld ent_intim(ix), a
        ld  a, ent_x(ix)
        ld  ent_inx(ix), a
        ld  a, ent_y(ix)
        ld  ent_iny(ix), a
        ld ent_tmp(ix), #2
        ld ent_initm(ix), #2

    no_level8_init:
    ret

;;===============================================================
;; Draw Obstacles
;; DESTROY: A,IX,HL,DE,BC
;; RETURNS: -
;;===============================================================
obstacle_draw::
    ;;Si no es game OVER
    ld  a, (game_over_control)
    cp  #1
    jp  z, es_gameover

        ld  a, (nivel_actual)  ;;comprueba los niveles donde hay diferentes obstaculos
        cp  #2
        jr  nz, no_level2_draw

            ld  ix, #carambano1_data
            ld  hl, #_obstac_sp_0        ;; HL = Sprite
            ld  a, #0                    ;; si es 0 (dibujar en ix)
            call drawEntity

            ld  ix, #carambano2_data
            ld  hl, #_obstac_sp_0        ;; HL = Sprite
            ld  a, #0                    ;; si es 0 (dibujar en ix)
            call drawEntity

        no_level2_draw:
        cp  #3
        jr  nz, no_level3_draw

            ld  ix, #cactus1_data
            ld  hl, #_obstac_sp_2        ;; HL = Sprite
            ld  a, #0                    ;; si es 0 (dibujar en ix)
            call drawEntity

            ld  ix, #cactus2_data
            ld  hl, #_obstac_sp_2        ;; HL = Sprite
            ld  a, #0                    ;; si es 0 (dibujar en ix)
            call drawEntity

            ld  ix, #cactus3_data
            ld  hl, #_obstac_sp_2        ;; HL = Sprite
            ld  a, #0                    ;; si es 0 (dibujar en ix)
            call drawEntity

            ld  ix, #chicago_data
            ld  hl, #_chicago_sp        ;; HL = Sprite
            ld  a, #0                    ;; si es 0 (dibujar en ix)
            call drawEntity

        no_level3_draw:
        cp  #5
        jr  nz, no_level5_draw

            ld  ix, #flecha1_data
            ld  hl, #_obstac_sp_1        ;; HL = Sprite
            ld  a, #0                    ;; si es 0 (dibujar en ix)
            call drawEntity

            ld  ix, #flecha2_data
            ld  hl, #_obstac_sp_3        ;; HL = Sprite
            ld  a, #0                    ;; si es 0 (dibujar en ix)
            call drawEntity

            ld  ix, #flecha3_data
            ld  hl, #_obstac_sp_3        ;; HL = Sprite
            ld  a, #0                    ;; si es 0 (dibujar en ix)
            call drawEntity

        no_level5_draw:
        cp  #6
        jr  nz, no_level6_draw

            ld  ix, #cactus1_data
            ld  hl, #_obstac_sp_2        ;; HL = Sprite
            ld  a, #0                    ;; si es 0 (dibujar en ix)
            call drawEntity

            ld  ix, #cactus2_data
            ld  hl, #_obstac_sp_2        ;; HL = Sprite
            ld  a, #0                    ;; si es 0 (dibujar en ix)
            call drawEntity

            ld  ix, #flecha1_data
            ld  hl, #_obstac_sp_1        ;; HL = Sprite
            ld  a, #0                    ;; si es 0 (dibujar en ix)
            call drawEntity

            ld  ix, #flecha2_data
            ld  hl, #_obstac_sp_3        ;; HL = Sprite
            ld  a, #0                    ;; si es 0 (dibujar en ix)
            call drawEntity

        no_level6_draw:
        cp  #7
        jr  nz, no_level7_draw

            ld  ix, #carambano1_data
            ld  hl, #_obstac_sp_0        ;; HL = Sprite
            ld  a, #0                    ;; si es 0 (dibujar en ix)
            call drawEntity

            ld  ix, #carambano2_data
            ld  hl, #_obstac_sp_0        ;; HL = Sprite
            ld  a, #0                    ;; si es 0 (dibujar en ix)
            call drawEntity

            ld  ix, #carambano3_data
            ld  hl, #_obstac_sp_0        ;; HL = Sprite
            ld  a, #0                    ;; si es 0 (dibujar en ix)
            call drawEntity

            ld  ix, #flecha1_data
            ld  hl, #_obstac_sp_1        ;; HL = Sprite
            ld  a, #0                    ;; si es 0 (dibujar en ix)
            call drawEntity

            ld  ix, #flecha2_data
            ld  hl, #_obstac_sp_3        ;; HL = Sprite
            ld  a, #0                    ;; si es 0 (dibujar en ix)
            call drawEntity

        no_level7_draw:
        cp  #8
        jr  nz, no_level8_draw

            ld  ix, #flecha1_data
            ld  hl, #_obstac_sp_1        ;; HL = Sprite
            ld  a, #0                    ;; si es 0 (dibujar en ix)
            call drawEntity

            ld  ix, #flecha2_data
            ld  hl, #_obstac_sp_3        ;; HL = Sprite
            ld  a, #0                    ;; si es 0 (dibujar en ix)
            call drawEntity

            ld  ix, #flecha3_data
            ld  hl, #_obstac_sp_3        ;; HL = Sprite
            ld  a, #0                    ;; si es 0 (dibujar en ix)
            call drawEntity

        no_level8_draw:
        ; ld ix, #pincho5_data
        ; ;;Calcular la posicion en pantalla
        ; ld  de, #0xC000                 ;; Video direcction pointer
        ; ld   c, ent_x(ix)        ;; C=entity_x
        ; ld   b, ent_y(ix)        ;; B=entity_y
        ; call cpct_getScreenPtr_asm
        ;
        ; ;;Dibujar obstaculo
        ; ex   de, hl                  ;; Intercambia hl por de
        ; ld   a, #0
        ; ld   b, ent_h(ix)           ;; B=Alto
        ; ld   c, ent_w(ix)           ;; C=Ancho
        ; call cpct_drawSolidBox_asm   ;; (esta en bytes)
    es_gameover:
    ret

;;===============================================================
;; Update Obstacles
;; DESTROY: A,IX,HL,DE,BC
;; RETURNS: -
;;===============================================================
obstacle_update::
    ;;Si no es game OVER
    ld  a, (game_over_control)
    cp  #1
    jp  z, es_gameover_up

        ld  a, (nivel_actual)  ;;comprueba los niveles donde hay diferentes obstaculos
        cp  #1
        jr  nz, no_level1

            ld  de, #pincho1_dw_x
            ld  iy, #pincho1_data
            call obstacle_colision

        no_level1:
        cp  #2
        jr  nz, no_level2

            ld  de, #carambano1_dw_x
            ld  iy, #carambano1_data
            call obstacle_colision
            ld  de, #carambano2_dw_x
            ld  iy, #carambano2_data
            call obstacle_colision

            ld  ix, #carambano1_data      ;; IX Puntero a los datos
            ld  a, ent_x(ix)
            ld  ent_antx(ix), a
            ld  a, ent_y(ix)
            ld  ent_anty(ix), a
            call carambano_animation

            ld  ix, #carambano2_data      ;; IX Puntero a los datos
            ld  a, ent_x(ix)
            ld  ent_antx(ix), a
            ld  a, ent_y(ix)
            ld  ent_anty(ix), a
            call carambano_animation

        no_level2:
        cp  #3
        jr  nz, no_level3

            ld  de, #cactus1_dw_x
            ld  iy, #cactus1_data
            call obstacle_colision

            ld  de, #cactus2_dw_x
            ld  iy, #cactus2_data
            call obstacle_colision

            ld  de, #cactus3_dw_x
            ld  iy, #cactus3_data
            call obstacle_colision

        no_level3:
        cp  #4
        jr  nz, no_level4

            ld  de, #pincho1_dw_x
            ld  iy, #pincho1_data
            call obstacle_colision

            ld  de, #pincho2_dw_x
            ld  iy, #pincho2_data
            call obstacle_colision

        no_level4:
        cp  #5
        jr  nz, no_level5

            ld  de, #flecha1_dw_x
            ld  iy, #flecha1_data
            call obstacle_colision
            ld  de, #flecha2_dw_x
            ld  iy, #flecha2_data
            call obstacle_colision
            ld  de, #flecha3_dw_x
            ld  iy, #flecha3_data
            call obstacle_colision

            ld  ix, #flecha1_data      ;; IX Puntero a los datos
            ld  a, ent_x(ix)
            ld  ent_antx(ix), a
            ld  a, ent_y(ix)
            ld  ent_anty(ix), a
            ld  a, #0
            call flecha_animation

            ld  ix, #flecha2_data      ;; IX Puntero a los datos
            ld  a, ent_x(ix)
            ld  ent_antx(ix), a
            ld  a, ent_y(ix)
            ld  ent_anty(ix), a
            ld  a, #1
            call flecha_animation

            ld  ix, #flecha3_data      ;; IX Puntero a los datos
            ld  a, ent_x(ix)
            ld  ent_antx(ix), a
            ld  a, ent_y(ix)
            ld  ent_anty(ix), a
            ld  a, #1
            call flecha_animation

        no_level5:
        cp  #6
        jr  nz, no_level6

            ld  de, #cactus1_dw_x
            ld  iy, #cactus1_data
            call obstacle_colision

            ld  de, #cactus2_dw_x
            ld  iy, #cactus2_data
            call obstacle_colision

            ld  de, #pincho1_dw_x
            ld  iy, #pincho1_data
            call obstacle_colision

            ld  de, #flecha1_dw_x
            ld  iy, #flecha1_data
            call obstacle_colision
            ld  de, #flecha2_dw_x
            ld  iy, #flecha2_data
            call obstacle_colision

            ld  ix, #flecha1_data      ;; IX Puntero a los datos
            ld  a, ent_x(ix)
            ld  ent_antx(ix), a
            ld  a, ent_y(ix)
            ld  ent_anty(ix), a
            ld  a, #0
            call flecha_animation

            ld  ix, #flecha2_data      ;; IX Puntero a los datos
            ld  a, ent_x(ix)
            ld  ent_antx(ix), a
            ld  a, ent_y(ix)
            ld  ent_anty(ix), a
            ld  a, #1
            call flecha_animation

        no_level6:
        cp  #7
        jp  nz, no_level7

            ld  de, #pincho1_dw_x
            ld  iy, #pincho1_data
            call obstacle_colision

            ld  de, #carambano1_dw_x
            ld  iy, #carambano1_data
            call obstacle_colision
            ld  de, #carambano2_dw_x
            ld  iy, #carambano2_data
            call obstacle_colision
            ld  de, #carambano3_dw_x
            ld  iy, #carambano3_data
            call obstacle_colision

            ld  de, #flecha1_dw_x
            ld  iy, #flecha1_data
            call obstacle_colision
            ld  de, #flecha2_dw_x
            ld  iy, #flecha2_data
            call obstacle_colision

            ld  ix, #carambano1_data      ;; IX Puntero a los datos
            ld  a, ent_x(ix)
            ld  ent_antx(ix), a
            ld  a, ent_y(ix)
            ld  ent_anty(ix), a
            call carambano_animation

            ld  ix, #carambano2_data      ;; IX Puntero a los datos
            ld  a, ent_x(ix)
            ld  ent_antx(ix), a
            ld  a, ent_y(ix)
            ld  ent_anty(ix), a
            call carambano_animation

            ld  ix, #carambano3_data      ;; IX Puntero a los datos
            ld  a, ent_x(ix)
            ld  ent_antx(ix), a
            ld  a, ent_y(ix)
            ld  ent_anty(ix), a
            call carambano_animation

            ld  ix, #flecha1_data      ;; IX Puntero a los datos
            ld  a, ent_x(ix)
            ld  ent_antx(ix), a
            ld  a, ent_y(ix)
            ld  ent_anty(ix), a
            ld  a, #0
            call flecha_animation

            ld  ix, #flecha2_data      ;; IX Puntero a los datos
            ld  a, ent_x(ix)
            ld  ent_antx(ix), a
            ld  a, ent_y(ix)
            ld  ent_anty(ix), a
            ld  a, #1
            call flecha_animation

        no_level7:
        cp  #8
        jp  nz, no_level8

            ld  de, #pincho1_dw_x
            ld  iy, #pincho1_data
            call obstacle_colision
            ld  de, #pincho2_dw_x
            ld  iy, #pincho2_data
            call obstacle_colision
            ld  de, #pincho3_dw_x
            ld  iy, #pincho3_data
            call obstacle_colision
            ld  de, #pincho4_dw_x
            ld  iy, #pincho4_data
            call obstacle_colision
            ld  de, #pincho5_dw_x
            ld  iy, #pincho5_data
            call obstacle_colision
            ld  de, #flecha1_dw_x
            ld  iy, #flecha1_data
            call obstacle_colision
            ld  de, #flecha2_dw_x
            ld  iy, #flecha2_data
            call obstacle_colision
            ld  de, #flecha3_dw_x
            ld  iy, #flecha3_data
            call obstacle_colision

            ld  ix, #flecha1_data      ;; IX Puntero a los datos
            ld  a, ent_x(ix)
            ld  ent_antx(ix), a
            ld  a, ent_y(ix)
            ld  ent_anty(ix), a
            ld  a, #0
            call flecha_animation

            ld  ix, #flecha2_data      ;; IX Puntero a los datos
            ld  a, ent_x(ix)
            ld  ent_antx(ix), a
            ld  a, ent_y(ix)
            ld  ent_anty(ix), a
            ld  a, #1
            call flecha_animation

            ld  ix, #flecha3_data      ;; IX Puntero a los datos
            ld  a, ent_x(ix)
            ld  ent_antx(ix), a
            ld  a, ent_y(ix)
            ld  ent_anty(ix), a
            ld  a, #1
            call flecha_animation

        no_level8:
    es_gameover_up:
    ret

;;===============================================================
;; Erase Obstacles
;; DESTROY: A,IX,HL,DE,BC
;; RETURNS: -
;;===============================================================
obstacle_erase::

    ld  a, (nivel_actual)  ;;comprueba los niveles donde hay diferentes obstaculos
    cp  #2
    jr  nz, no_level2_erase

        ld  ix, #carambano1_data
        ld  a, #0                    ;; si es 0 (dibujar en ix)
        ld  h, ent_antx(ix)
        ld  l, ent_anty(ix)
        call eraseEntity

        ld  ix, #carambano2_data
        ld  a, #0                    ;; si es 0 (dibujar en ix)
        ld  h, ent_antx(ix)
        ld  l, ent_anty(ix)
        call eraseEntity

    no_level2_erase:
    ld  a, (nivel_actual)  ;;comprueba los niveles donde hay diferentes obstaculos
    cp  #3
    jr  nz, no_level3_erase

        ld  ix, #cactus1_data
        ld  a, #0                    ;; si es 0 (dibujar en ix)
        ld  h, ent_antx(ix)
        ld  l, ent_anty(ix)
        call eraseEntity

        ld  ix, #cactus2_data
        ld  a, #0                    ;; si es 0 (dibujar en ix)
        ld  h, ent_antx(ix)
        ld  l, ent_anty(ix)
        call eraseEntity

        ld  ix, #cactus3_data
        ld  a, #0                    ;; si es 0 (dibujar en ix)
        ld  h, ent_antx(ix)
        ld  l, ent_anty(ix)
        call eraseEntity

        ld  ix, #chicago_data
        ld  a, #0                    ;; si es 0 (dibujar en ix)
        ld  h, ent_x(ix)
        ld  l, ent_y(ix)
        call eraseEntity

    no_level3_erase:
    cp  #5
    jr  nz, no_level5_erase

        ld  ix, #flecha1_data
        ld  a, #0                    ;; si es 0 (dibujar en ix)
        ld  h, ent_antx(ix)
        ld  l, ent_anty(ix)
        call eraseEntity

        ld  ix, #flecha2_data
        ld  a, #0                    ;; si es 0 (dibujar en ix)
        ld  h, ent_antx(ix)
        ld  l, ent_anty(ix)
        call eraseEntity

        ld  ix, #flecha3_data
        ld  a, #0                    ;; si es 0 (dibujar en ix)
        ld  h, ent_antx(ix)
        ld  l, ent_anty(ix)
        call eraseEntity


    no_level5_erase:
    cp  #6
    jr  nz, no_level6_erase

        ld  ix, #cactus1_data
        ld  a, #0                    ;; si es 0 (dibujar en ix)
        ld  h, ent_antx(ix)
        ld  l, ent_anty(ix)
        call eraseEntity

        ld  ix, #cactus2_data
        ld  a, #0                    ;; si es 0 (dibujar en ix)
        ld  h, ent_antx(ix)
        ld  l, ent_anty(ix)
        call eraseEntity

        ld  ix, #flecha1_data
        ld  a, #0                    ;; si es 0 (dibujar en ix)
        ld  h, ent_antx(ix)
        ld  l, ent_anty(ix)
        call eraseEntity

        ld  ix, #flecha2_data
        ld  a, #0                    ;; si es 0 (dibujar en ix)
        ld  h, ent_antx(ix)
        ld  l, ent_anty(ix)
        call eraseEntity

    no_level6_erase:
    cp  #7
    jr  nz, no_level7_erase

        ld  ix, #carambano1_data
        ld  a, #0                    ;; si es 0 (dibujar en ix)
        ld  h, ent_antx(ix)
        ld  l, ent_anty(ix)
        call eraseEntity

        ld  ix, #carambano2_data
        ld  a, #0                    ;; si es 0 (dibujar en ix)
        ld  h, ent_antx(ix)
        ld  l, ent_anty(ix)
        call eraseEntity

        ld  ix, #carambano3_data
        ld  a, #0                    ;; si es 0 (dibujar en ix)
        ld  h, ent_antx(ix)
        ld  l, ent_anty(ix)
        call eraseEntity

        ld  ix, #flecha1_data
        ld  a, #0                    ;; si es 0 (dibujar en ix)
        ld  h, ent_antx(ix)
        ld  l, ent_anty(ix)
        call eraseEntity

        ld  ix, #flecha2_data
        ld  a, #0                    ;; si es 0 (dibujar en ix)
        ld  h, ent_antx(ix)
        ld  l, ent_anty(ix)
        call eraseEntity

    no_level7_erase:
    cp  #8
    jr  nz, no_level8_erase

        ld  ix, #flecha1_data
        ld  a, #0                    ;; si es 0 (dibujar en ix)
        ld  h, ent_antx(ix)
        ld  l, ent_anty(ix)
        call eraseEntity

        ld  ix, #flecha2_data
        ld  a, #0                    ;; si es 0 (dibujar en ix)
        ld  h, ent_antx(ix)
        ld  l, ent_anty(ix)
        call eraseEntity

        ld  ix, #flecha3_data
        ld  a, #0                    ;; si es 0 (dibujar en ix)
        ld  h, ent_antx(ix)
        ld  l, ent_anty(ix)
        call eraseEntity

    no_level8_erase:
    ret

;;===============================================================
;;===============================================================
;; PRIVATE FUNCTION
;;===============================================================
;;===============================================================

;;===============================================================
;; Animacion y colision carambano
;; DESTROY: A,IX,HL,DE,BC
;; RETURNS: -
;;===============================================================
carambano_animation:
    ;;Si el contador llega a 0, activar caida
    ld  a, ent_tmpa(ix)
    dec a
    ld  ent_tmpa(ix), a
    cp  #0
    jp  nz, no_activado
        ;;Activar caida
        ld  ent_ac(ix), #1
    no_activado:

    ;;Caida activada entonces animacion
    ld  a, ent_ac(ix)
    cp  #1
    jr  nz, no_cae

        ;;Cae rapido
        ld  a, ent_y(ix)
        inc a
        inc a
        ld ent_y(ix), a
        ;;Si llega abajo reiniciar y, y tiempo, y desactivar caida
        cp #190
        jr  nz, no_reiniciar_caramb
            ld  a, ent_iny(ix)
            ld  ent_y(ix), a
            ld  a, ent_intim(ix)
            ld  ent_tmpa(ix), a
            ld  ent_ac(ix), #0
        no_reiniciar_caramb:
    no_cae:
    ret

;;===============================================================
;; Animacion y colision flecha
;; DESTROY: A,IX,HL,DE,BC
;; INPUT:  A: 0:Derecha, 1:Izquierda
;; RETURNS: -
;;===============================================================
flecha_animation:
    push af
    ;;Si el contador llega a 0, activar caida
    ld  a, ent_tmpa(ix)
    dec a
    ld  ent_tmpa(ix), a
    cp  #0
    jp  nz, no_activado2
        ;;Activar caida
        ld  ent_ac(ix), #1
    no_activado2:

    ;;Caida activada entonces animacion
    ld  a, ent_ac(ix)
    cp  #1
    jr  nz, no_cae2

        ;;Cae rapido
        pop af
        cp  #0
        jr  nz, desde_la_der
            ld  a, ent_x(ix)
            inc a
            inc a
            ld ent_x(ix), a
            cp #76
            jr  nz, no_reiniciar_flecha
            jr  continuar_refle
        desde_la_der:
            ld  a, ent_x(ix)
            dec a
            dec a
            ld ent_x(ix), a
            cp #0
            jr  nz, no_reiniciar_flecha
        continuar_refle:
        ;;Si llega abajo reiniciar x, y tiempo, y desactivar caida
            ld  a, ent_inx(ix)
            ld  ent_x(ix), a
            ld  a, ent_intim(ix)
            ld  ent_tmpa(ix), a
            ld  ent_ac(ix), #0
        no_reiniciar_flecha:
        ;;Borrar flecha
        ld  a, #0                    ;; si es 0 (dibujar en ix)
        ld  h, ent_antx(ix)
        ld  l, ent_anty(ix)
        call eraseEntity
        ret
    no_cae2:
    pop af
    ret

;;===============================================================
;; Colision a heroe
;; DESTROY: A,IX,HL,DE,BC
;; RETURNS: -
;; INPUT:
;;          DE: puntero a x
;;          IY: puntero a data
;;===============================================================
obstacle_colision:
    call hero_getPtrHL
    call checkCollision      ;;comprueba colision
    cp #0
    jr z, no_hay_colision

        ld  a, ent_tmp(iy)
        dec a
        ld  ent_tmp(iy), a
        cp  #0
        jr  nz, no_hay_tiempo

            call Quitar_Vida
            ld  a, ent_initm(iy)
            ld  ent_tmp(iy), a

        no_hay_tiempo:
        ret
    no_hay_colision:
    ret
