;; INFO LICENSE
;;    This file is part of SnakeBubble.
;;    Copyright (C) 2018-2019 David Ramon Sevilla / Jose Vicente Anton Coy	
;;    SnakeBubble is free software: you can redistribute it and/or modify
;;    it under the terms of the GNU General Public License as published by
;;    the Free Software Foundation, either version 3 of the License, or
;;    (at your option) any later version.
;;
;;    SnakeBubble is distributed in the hope that it will be useful,
;;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;    GNU General Public License for more details.
;;
;;    You should have received a copy of the GNU General Public License
;;    along with SnakeBubble.  If not, see <https://www.gnu.org/licenses/>.
;;---------------------------------Fin license info----------------------------------------

.area _DATA
.area _CODE

.include "cpctelera.h.s"    ;;CPCtelera simbolos
.include "entity.h.s"
.include "collider.h.s"

;;===============================================================
;;===============================================================
;; PRIVATE DATA
;;===============================================================
;;===============================================================

;;plataform dates
.macro definePlataformEntity name, x, y, w, h
    name'_data:
        ;;No tiene parte dibujable
        name'_x:     .db x       ;; Pos x
        name'_y:     .db y       ;; Pos y
        name'_w:     .db w       ;; Ancho
        name'_h:     .db h       ;; Alto
.endm

;;Constantes de las estructuras de datos
.equ ent_x, 0
.equ ent_y, 1
.equ ent_w, 2
.equ ent_h, 3
.equ en_sL, 10 ;byte bajo
.equ en_sH, 11 ;byte alto
.equ en_eL, 12 ;byte bajo
.equ en_sH, 13 ;byte alto

num_pla: .db #3         ;; Numero de plataformas
tam_pla = 4         ;; Numero de datos de cada entidad

comprobando: .dw #0x00,#0xC0

;;Datos de Plataformas
definePlataformEntity plataform  10 152 #0x16 #0x01
definePlataformEntity plataform2 48 152 #0x16 #0x01
definePlataformEntity plataform3 29 112 #0x16 #0x01
definePlataformEntity plataform4 0 0 #0x01 #0x01
definePlataformEntity plataform5 0 0 #0x01 #0x01
definePlataformEntity plataform6 0 0 #0x01 #0x01

;;===============================================================
;;===============================================================
;; PUBLIC FUNCTION
;;===============================================================
;;===============================================================

;;===============================================================
;; Inicialize plataform
;; DESTROY: -
;; RETURNS: -
;;===============================================================
plat_init::
    ld ix, #plataform_data      ;; IX Puntero a los datos

    ;;level 0
    cp #0
    jr nz, plataform_level1
        ld  a, #3
        ld  (num_pla), a

        ld ix, #plataform_data      ;; IX Puntero a los datos
        ld ent_x(ix), #10
        ld ent_y(ix), #152
        ld ent_w(ix), #0x16
        ld ent_h(ix), #0x01

        ld ix, #plataform2_data      ;; IX Puntero a los datos
        ld ent_x(ix), #48
        ld ent_y(ix), #152
        ld ent_w(ix), #0x16
        ld ent_h(ix), #0x01

        ld ix, #plataform3_data      ;; IX Puntero a los datos
        ld ent_x(ix), #29
        ld ent_y(ix), #112
        ld ent_w(ix), #0x16
        ld ent_h(ix), #0x01

        ret
    plataform_level1:
    ;;level 1
    cp #1
    jr nz, plataform_level2
        ld  a, #6
        ld  (num_pla), a

        ld ix, #plataform_data      ;; IX Puntero a los datos
        ld ent_x(ix), #5
        ld ent_y(ix), #152
        ld ent_w(ix), #0x16
        ld ent_h(ix), #0x01

        ld ix, #plataform2_data      ;; IX Puntero a los datos
        ld ent_x(ix), #53
        ld ent_y(ix), #152
        ld ent_w(ix), #0x16
        ld ent_h(ix), #0x01

        ld ix, #plataform3_data      ;; IX Puntero a los datos
        ld ent_x(ix), #5
        ld ent_y(ix), #112
        ld ent_w(ix), #0x16
        ld ent_h(ix), #0x01

        ld ix, #plataform4_data      ;; IX Puntero a los datos
        ld ent_x(ix), #53
        ld ent_y(ix), #112
        ld ent_w(ix), #0x16
        ld ent_h(ix), #0x01

        ld ix, #plataform5_data      ;; IX Puntero a los datos
        ld ent_x(ix), #5
        ld ent_y(ix), #72
        ld ent_w(ix), #0x16
        ld ent_h(ix), #0x01

        ld ix, #plataform6_data      ;; IX Puntero a los datos
        ld ent_x(ix), #53
        ld ent_y(ix), #72
        ld ent_w(ix), #0x16
        ld ent_h(ix), #0x01

        ret
    plataform_level2:
    ;;level 2
    cp #2
    jr nz, plataform_level3
        ld  a, #4
        ld  (num_pla), a

        ld ix, #plataform_data      ;; IX Puntero a los datos
        ld ent_x(ix), #4
        ld ent_y(ix), #152
        ld ent_w(ix), #0x0F
        ld ent_h(ix), #0x01

        ld ix, #plataform2_data      ;; IX Puntero a los datos
        ld ent_x(ix), #33
        ld ent_y(ix), #128
        ld ent_w(ix), #0x0E
        ld ent_h(ix), #0x01

        ld ix, #plataform3_data      ;; IX Puntero a los datos
        ld ent_x(ix), #61
        ld ent_y(ix), #104
        ld ent_w(ix), #0x0F
        ld ent_h(ix), #0x01

        ld ix, #plataform4_data      ;; IX Puntero a los datos
        ld ent_x(ix), #4
        ld ent_y(ix), #64
        ld ent_w(ix), #0x50
        ld ent_h(ix), #0x01

        ld ix, #plataform5_data      ;; IX Puntero a los datos
        ld ent_x(ix), #0
        ld ent_y(ix), #0
        ld ent_w(ix), #0x01
        ld ent_h(ix), #0x01

        ld ix, #plataform6_data      ;; IX Puntero a los datos
        ld ent_x(ix), #0
        ld ent_y(ix), #0
        ld ent_w(ix), #0x01
        ld ent_h(ix), #0x01

        ret
    plataform_level3:
    ;;level 3
    cp #3
    jr nz, plataform_level4
        ld  a, #5
        ld  (num_pla), a

        ld ix, #plataform_data      ;; IX Puntero a los datos
        ld ent_x(ix), #4
        ld ent_y(ix), #168
        ld ent_w(ix), #0x17
        ld ent_h(ix), #0x01

        ld ix, #plataform2_data      ;; IX Puntero a los datos
        ld ent_x(ix), #53
        ld ent_y(ix), #136
        ld ent_w(ix), #0x17
        ld ent_h(ix), #0x01

        ld ix, #plataform3_data      ;; IX Puntero a los datos
        ld ent_x(ix), #4
        ld ent_y(ix), #104
        ld ent_w(ix), #0x1F
        ld ent_h(ix), #0x01

        ld ix, #plataform4_data      ;; IX Puntero a los datos
        ld ent_x(ix), #4
        ld ent_y(ix), #64
        ld ent_w(ix), #0x0F
        ld ent_h(ix), #0x01

        ld ix, #plataform5_data      ;; IX Puntero a los datos
        ld ent_x(ix), #45
        ld ent_y(ix), #56
        ld ent_w(ix), #0x1F
        ld ent_h(ix), #0x01

        ld ix, #plataform6_data      ;; IX Puntero a los datos
        ld ent_x(ix), #0
        ld ent_y(ix), #0
        ld ent_w(ix), #0x01
        ld ent_h(ix), #0x01


        ret
    plataform_level4:
    ;;level 4
    cp #4
    jr nz, plataform_level5
        ld  a, #5
        ld  (num_pla), a

        ld ix, #plataform_data      ;; IX Puntero a los datos
        ld ent_x(ix), #17
        ld ent_y(ix), #152
        ld ent_w(ix), #0x06
        ld ent_h(ix), #0x01

        ld ix, #plataform2_data      ;; IX Puntero a los datos
        ld ent_x(ix), #25
        ld ent_y(ix), #144
        ld ent_w(ix), #0x26
        ld ent_h(ix), #0x01

        ld ix, #plataform3_data      ;; IX Puntero a los datos
        ld ent_x(ix), #61
        ld ent_y(ix), #112
        ld ent_w(ix), #0x0D
        ld ent_h(ix), #0x01

        ld ix, #plataform4_data      ;; IX Puntero a los datos
        ld ent_x(ix), #6
        ld ent_y(ix), #104
        ld ent_w(ix), #0x0D
        ld ent_h(ix), #0x01

        ld ix, #plataform5_data      ;; IX Puntero a los datos
        ld ent_x(ix), #21
        ld ent_y(ix), #64
        ld ent_w(ix), #0x26
        ld ent_h(ix), #0x01

        ld ix, #plataform6_data      ;; IX Puntero a los datos
        ld ent_x(ix), #0
        ld ent_y(ix), #0
        ld ent_w(ix), #0x01
        ld ent_h(ix), #0x01

        ret
    plataform_level5:
    ;;level 5
    cp #5
    jr nz, plataform_level6
        ld  a, #6
        ld  (num_pla), a

        ld ix, #plataform_data      ;; IX Puntero a los datos
        ld ent_x(ix), #16
        ld ent_y(ix), #152
        ld ent_w(ix), #0x10
        ld ent_h(ix), #0x01

        ld ix, #plataform2_data      ;; IX Puntero a los datos
        ld ent_x(ix), #48
        ld ent_y(ix), #152
        ld ent_w(ix), #0x10
        ld ent_h(ix), #0x01

        ld ix, #plataform3_data      ;; IX Puntero a los datos
        ld ent_x(ix), #16
        ld ent_y(ix), #112
        ld ent_w(ix), #0x10
        ld ent_h(ix), #0x01

        ld ix, #plataform4_data      ;; IX Puntero a los datos
        ld ent_x(ix), #48
        ld ent_y(ix), #112
        ld ent_w(ix), #0x10
        ld ent_h(ix), #0x01

        ld ix, #plataform5_data      ;; IX Puntero a los datos
        ld ent_x(ix), #16
        ld ent_y(ix), #72
        ld ent_w(ix), #0x10
        ld ent_h(ix), #0x01

        ld ix, #plataform6_data      ;; IX Puntero a los datos
        ld ent_x(ix), #48
        ld ent_y(ix), #72
        ld ent_w(ix), #0x10
        ld ent_h(ix), #0x01

        ret
    plataform_level6:
    ;;level 6
    cp #6
    jr nz, plataform_level7
        ld  a, #6
        ld  (num_pla), a

        ld ix, #plataform_data      ;; IX Puntero a los datos
        ld ent_x(ix), #60
        ld ent_y(ix), #176
        ld ent_w(ix), #0x10
        ld ent_h(ix), #0x01

        ld ix, #plataform2_data      ;; IX Puntero a los datos
        ld ent_x(ix), #16
        ld ent_y(ix), #144
        ld ent_w(ix), #0x10
        ld ent_h(ix), #0x01

        ld ix, #plataform3_data      ;; IX Puntero a los datos
        ld ent_x(ix), #4
        ld ent_y(ix), #104
        ld ent_w(ix), #0x08
        ld ent_h(ix), #0x01

        ld ix, #plataform4_data      ;; IX Puntero a los datos
        ld ent_x(ix), #16
        ld ent_y(ix), #96
        ld ent_w(ix), #0x38
        ld ent_h(ix), #0x01

        ld ix, #plataform5_data      ;; IX Puntero a los datos
        ld ent_x(ix), #68
        ld ent_y(ix), #56
        ld ent_w(ix), #0x08
        ld ent_h(ix), #0x01

        ld ix, #plataform6_data      ;; IX Puntero a los datos
        ld ent_x(ix), #8
        ld ent_y(ix), #48
        ld ent_w(ix), #0x38
        ld ent_h(ix), #0x01

        ret
    plataform_level7:
    ;;level 7
    cp #7
    jr nz, plataform_level8
        ld  a, #6
        ld  (num_pla), a

        ld ix, #plataform_data      ;; IX Puntero a los datos
        ld ent_x(ix), #33
        ld ent_y(ix), #160
        ld ent_w(ix), #0x0E
        ld ent_h(ix), #0x01

        ld ix, #plataform2_data      ;; IX Puntero a los datos
        ld ent_x(ix), #57
        ld ent_y(ix), #128
        ld ent_w(ix), #0x12
        ld ent_h(ix), #0x01

        ld ix, #plataform3_data      ;; IX Puntero a los datos
        ld ent_x(ix), #5
        ld ent_y(ix), #128
        ld ent_w(ix), #0x12
        ld ent_h(ix), #0x01

        ld ix, #plataform4_data      ;; IX Puntero a los datos
        ld ent_x(ix), #29
        ld ent_y(ix), #96
        ld ent_w(ix), #0x16
        ld ent_h(ix), #0x01

        ld ix, #plataform5_data      ;; IX Puntero a los datos
        ld ent_x(ix), #5
        ld ent_y(ix), #64
        ld ent_w(ix), #0x12
        ld ent_h(ix), #0x01

        ld ix, #plataform6_data      ;; IX Puntero a los datos
        ld ent_x(ix), #57
        ld ent_y(ix), #64
        ld ent_w(ix), #0x12
        ld ent_h(ix), #0x01

        ret
    plataform_level8:
    ;;level 8
    cp #8
    jr nz, plataform_level9
        ld  a, #6
        ld  (num_pla), a

        ld ix, #plataform_data      ;; IX Puntero a los datos
        ld ent_x(ix), #37
        ld ent_y(ix), #177
        ld ent_w(ix), #0x06
        ld ent_h(ix), #0x01

        ld ix, #plataform2_data      ;; IX Puntero a los datos
        ld ent_x(ix), #61
        ld ent_y(ix), #152
        ld ent_w(ix), #0x0E
        ld ent_h(ix), #0x01

        ld ix, #plataform3_data      ;; IX Puntero a los datos
        ld ent_x(ix), #5
        ld ent_y(ix), #152
        ld ent_w(ix), #0x0E
        ld ent_h(ix), #0x01

        ld ix, #plataform4_data      ;; IX Puntero a los datos
        ld ent_x(ix), #33
        ld ent_y(ix), #128
        ld ent_w(ix), #0x0E
        ld ent_h(ix), #0x01

        ld ix, #plataform5_data      ;; IX Puntero a los datos
        ld ent_x(ix), #33
        ld ent_y(ix), #88
        ld ent_w(ix), #0x0E
        ld ent_h(ix), #0x01

        ld ix, #plataform6_data      ;; IX Puntero a los datos
        ld ent_x(ix), #4
        ld ent_y(ix), #48
        ld ent_w(ix), #0x50
        ld ent_h(ix), #0x01

        ret
    plataform_level9:
    ret

;;===============================================================
;; Erases the plataform
;; DESTROY: AF, BC, HL
;;===============================================================
; plataform_erase::
;     ld   a, (num_pla)          ;; Numero de plataformas a dibujar
;     ld  ix, #plataform_data   ;; IX Puntero a los datos de la primera plataforma
;
;     bucle_erase:
;         push af                   ;; Guardar el contador A
;
;         ld   a, #0x00             ;; Color plataform
;         call drawPlataform        ;; Draw our plataform
;         ld  bc, #tam_pla          ;; tam_pla
;         add ix, bc                ;; plataform_data + tam_pla = siguiente plataforma
;
;         pop  af                   ;; Cargar el contador en A
;         dec a
;         jr  nz, bucle_erase       ;; Dibujar tantas plataformas como num_pla
;
;     ret

;;===============================================================
;; Updates the plataform
;; DESTROY: AF, BC, HL
;;===============================================================
plataform_update::
    ;;PLATAFORM
    ld  hl, #plataform_x                ;; Puntero plataform_x en hl
    call collPlataform
    cp #1                               ;; Si A==1 ha colisionado
    ret z                               ;; ret si ha colisionado

    ;;PLATAFORM 2
    ld   hl, #plataform2_x              ;; Puntero plataform2_x en hl
    call collPlataform
    cp #1                               ;; Si A==1 ha colisionado
    ret z                               ;; ret si ha colisionado

    ;;PLATAFORM 3
    ld   hl, #plataform3_x              ;;  Puntero plataform3_x en hl
    call collPlataform
    cp #1                               ;; Si A==1 ha colisionado
    ret z                               ;; ret si ha colisionado

    ;;PLATAFORM 4
    ld   hl, #plataform4_x              ;;  Puntero plataform3_x en hl
    call collPlataform
    cp #1                               ;; Si A==1 ha colisionado
    ret z                               ;; ret si ha colisionado

    ;;PLATAFORM 5
    ld   hl, #plataform5_x              ;;  Puntero plataform3_x en hl
    call collPlataform
    cp #1                               ;; Si A==1 ha colisionado
    ret z                               ;; ret si ha colisionado

    ;;PLATAFORM 6
    ld   hl, #plataform6_x              ;;  Puntero plataform3_x en hl
    call collPlataform
    cp #1                               ;; Si A==1 ha colisionado
    ret z                               ;; ret si ha colisionado

        ld ix,(comprobando);cargamos el puntero de entidad a la que le estamos comprobando la colision
        ld h, 13(ix)  ; pasamos el byte bajo de la llamada a endcollision
        ld l, 12(ix)  ; pasamos el byte alto de la llamada a endcollision

        ;; NO HAY COLISION CON NINGUNA PLATAFORMA
        ld bc,#salt ;guardamos la posicion de memoria que debemos saltar luego de hacer la operacion
        push bc ;guardamos en la pila
        jp (hl) ;realizamos el salto a endcollision de la entidad
        salt:;para seguir la ejecucion normal
    ret

;;===============================================================
;; Draws the plataform
;; DESTROY: AF, BC, HL
;;===============================================================
; plataform_draw::
;     ld   a, (num_pla)          ;; Numero de plataformas a dibujar
;     ld  ix, #plataform_data   ;; IX Puntero a los datos de la primera plataforma
;
;     bucle_draw:
;         push af                   ;; Guardar el contador A
;
;         ld   a, #0x00             ;; Color plataform
;         call drawPlataform        ;; Draw our plataform
;         ld  bc, #tam_pla          ;; tam_pla
;         add ix, bc                ;; plataform_data + tam_pla = siguiente plataforma
;
;         pop  af                   ;; Cargar el contador en A
;         dec a
;         jr  nz, bucle_draw        ;; Dibujar tantas plataformas como num_pla
;
;     ret
; Cambia la entidad con la que comprueba las colisiones
setComprobando::
    ld (comprobando),ix
ret
;;===============================================================
;;===============================================================
;; PRIVATE FUNCTION
;;===============================================================
;;===============================================================

;;===============================================================
;; Plataform Collider
;; Input:
;;       HL: Puntero al primer dato de la plataforma
;; Output:
;;        A: Si es 1 es que ha colisionado con esta plataforma
;; DESTROY: AF, BC, DE, HL
;;===============================================================
collPlataform:
    ld  d, h                            ;; |
    ld  e, l                            ;; \ DE = plataform_x
    ld   hl, (comprobando)              ;; pasamos el puntero a hl
    call checkCollision_Plataform       ;; Check collision A=(0: no_collision, 1: si_collision)
    cp #0
    jr z, other_col                     ;; Si no_collision, comprobar siguiente plataforma

        ld h, 11(ix)  ; pasamos el byte bajo de la llamada a endcollision
        ld l, 10(ix)  ; pasamos el byte alto de la llamada a endcollision
        ld bc,#aqui2
        push bc
        jp (hl)
        aqui2:                                ;; iniciar colision
        ld  a, #1                       ;; If (a==1), entonces ha colisionado
        ret
    other_col:
    ld  a, #0                           ;; If (a==0), NO ha colisionado
ret
;;===============================================================
;; Plataform Draws
;; DESTROY: AF, BC, DE, HL
;;===============================================================
; drawPlataform:
;     push af     ;;Guarda A en la pila (color)
;
;     ;;Calcular la posicion en pantalla
;     ld  de, #0xC000                 ;; Video direcction pointer
;     ld   c, ent_x(ix)        ;; C=entity_x
;     ld   b, ent_y(ix)        ;; B=entity_y
;     call cpct_getScreenPtr_asm
;
;     ;;Dibujar obstaculo
;     ex   de, hl                  ;; Intercambia hl por de
;     pop  af                      ;; A=Color seleccionado por usuario
;     ld   b, ent_h(ix)           ;; B=Alto
;     ld   c, ent_w(ix)           ;; C=Ancho
;     call cpct_drawSolidBox_asm   ;; (esta en bytes)
;
;     ret
